//--------------------------------------
// Hard target rifle
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(HTrifleFireSound)
{
   filename    = "~/data/sound/contenderFire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(HTrifleSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(HTrifleDryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

//shells
datablock DebrisData(HTrifleshell)
{
   shapeFile = "~/data/shapes/weapons/bmgShell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
   scale = "2 2 2";
};
//------------------
//   ammo
//------------------
datablock ItemData(HTrifleammo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/HTrifleClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some .50 bmg rounds";
	computeCRC = true;
};

datablock ItemData(HTrifleClip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/HTrifleClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some HT-Rifle clips";
	computeCRC = true;
	scale = "2 2 2";
	maxInventory = 6;
};

/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(HTrifle_noclip)
{
	category = "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/HTrifle_noclip.dts";
	image = HTrifle_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty HT-Rifle";
	computeCRC = true;
	emap = true;
	packImage = HTrifle_noclipPackImage;
	slot = $PrimarySlot;
	emptyItem = HTrifle_noclip;
	fullItem = HTrifle;
};
datablock ShapeBaseImageData(HTrifle_noclipPackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/HTrifle.dts";
	emap = true;
	mountPoint = 1;
	offset = "0.07 -0.05 0";
	rotation = "1 0 0 90";
};
datablock ShapeBaseImageData(HTrifle_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/HTrifle_noclip.dts";
	item = HTrifle_noclip;
	ammo = HTrifleammo;
	clip = HTrifleclip;
	offset = "0 0 0";
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 3.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};

//function HTrifle_noclipImage::onAddClip(%this, %obj, %slot)
//{	
//	%clip = %this.clip;
//	%ammo = %this.ammo;
//	//if they have a clip
//	if( %obj.getInventory(%clip) )
//	{	
//		%obj.decInventory(HTrifle_noclip, 1);		//take the player's noclip
//		%obj.incInventory(HTrifle, 1);	//hack		//give them a regular 
//		%obj.decInventory(HTrifleclip, 1);		//take away 1  clip
//		%obj.incInventory(HTrifleammo, 400);		//give them  rounds
//
//		//fix mounts
//		%obj.unmountImage(%slot);
//		%obj.mountImage(HTrifleImage, %slot);	//hack
//	}
//	else
//		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more HT-Rifle clips!~wfx/misc/misc.error.wav' );
//}
//function HTrifle_noclipImage::changeClip(%this, %obj, %slot)
//{	
//	%obj.decinventory(HTrifle_noclip, 1);
//	%obj.unmountImage(%slot);
//	%obj.incinventory(HTrifle_noclip, 1);
//	%obj.mountImage(HTrifle_noclipImage, %slot);		
//}

//////////
//weapon//
//////////
datablock ItemData(HTrifle)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/HTrifle.dts";
	image		= HTrifleImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "an HT-Rifle";
	computeCRC	= true;
	emap		= true;
	packImage	= HTriflepackImage;
	slot		= $PrimarySlot;
	emptyItem	= HTrifle_noclip;
};
datablock ShapeBaseImageData(HTriflepackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/HTrifle.dts";
	emap = true;
	mountPoint = 1;
	offset = "0.07 -0.05 0";
	rotation = "1 0 0 90";
};

datablock ShapeBaseImageData(HTrifleImage)
{
	accuracy = 0.025;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/HTrifle.dts";
	item = HTrifle;
	ammo = HTrifleammo;
	clip = HTrifleclip;
	offset = "0 0 0";
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	casing              = HTrifleshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = HTrifleSwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.75;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = HTrifleFireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = HTrifleDryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";
};

//function HTrifleImage::changeClip(%data, %obj, %slot)
//{
//	if(%obj.getinventory(HTrifleammo) == %obj.getDatablock().maxInv[HTrifleammo] )	//got full ammo?
//	{
//		messageclient(%obj.client, sometype, '\c2Magazine already full');
//		return;
//	}
//	if(%obj.getinventory(HTrifleclip) )			//got any clips left?
//	{
//		%obj.decInventory(HTrifle, 1);			//take away 
//		%obj.incInventory(HTrifle_noclip, 1);		//give noclip 
//		//throw clip debris here??
//		%obj.unmountImage(%slot);			//unnessesary? 
//		%obj.mountImage(HTrifle_noclipImage, %slot);	//dont forget that you mount IMAGES 
//	}
//	else
//	{
//		if(%obj.getinventory(HTrifleammo) == 0 )	//empty mag? toss it.
//		{
//			%obj.decInventory(HTrifle, 1);			//take away 
//			%obj.incInventory(HTrifle_noclip, 1);		//give noclip 
//			//throw clip debris here??
//			%obj.unmountImage(%slot);			//unnessesary? 
//			%obj.mountImage(HTrifle_noclipImage, %slot);	//dont forget that you mount IMAGES 	
//		}
//		else
//			messageclient(%obj.client, sometype, "\c2You're on your last clip...");
//		return;
//	}
//	
//}