datablock WheeledVehicleData(ball)
{
   category = "Vehicles";
   displayName = " ";
   shapeFile = "~/data/shapes/vehicles/ball.dts";
   emap = true;
   nummountpoints = 1;
   minMountDist = 1;

	maxDamage = 200;
	destroyedLevel = 200;
	isShielded = false;

   maxSteeringAngle = 0.785;  // Maximum steering angle, should match animation
   integration = 1;           // Force integration time: TickSec/Rate
   tireEmitter = TireEmitter; // All the tires use the same dust emitter

   // 3rd person camera settings
   cameraRoll = true;  
	cameraMaxDist = 15;
	cameraOffset = 2.5;
	cameraLag = 0.0;
	cameraDecay = 0.75; 
	
   useEyePoint = true;	



	defaultTire	= "";
	defaultSpring	= "";
	flatTire	= "";
	flatSpring	= "";


   // Rigid Body
   density = 0.5;
   mass = 100;
   drag = 0.5;
   bodyFriction = 0.9; //0.06;
   bodyRestitution = 0.4;
   minImpactSpeed = 5;        // Impacts over this invoke the script callback
   softImpactSpeed = 5;       // Play SoftImpact Sound
   hardImpactSpeed = 15;      // Play HardImpact Sound
   groundImpactMinSpeed    = 10.0;

   // Engine
   engineTorque = 8000; //4000;       // Engine power
   engineBrake = 6000;         // Braking when throttle is 0
   brakeTorque = 50000;        // When brakes are applied
   maxWheelSpeed = 60;        // Engine scale by current speed / max speed

   // Energy
   maxEnergy = 100;
   jetForce = 3000;
   minJetEnergy = 30;
   jetEnergyDrain = 2;


   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;


	damageEmitter[0] = p51CrashSmokeEmitter1;
	damageEmitter[1] = p51CrashSmokeEmitter2;
	damageEmitter[2] = p51CrashSmokeEmitter3;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageEmitterOffset[1] = "0.0 2.0 0.0 ";
	damageLevelTolerance[0] = 0.3;
	damageLevelTolerance[1] = 0.7;
	numDmgEmitterAreas = 3;

   // Sounds
//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	wheelImpactSound = clatchSound;

//   explosion = VehicleExplosion;
	justcollided = 0;

	maxinv[p51ammo] = 1000;


};

function ball::onAdd(%this,%obj)
{
	//do nothing, ie dont add wheels
	//%obj.setDamageLevel(200);
	%obj.setShapeName(%obj.getDataBlock().displayName);


}


datablock ItemData(ballSpawner)
{
	category = "Special";
	className = "Ammo";
	shapeFile = "~/data/shapes/markers/octahedron.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 0;
	computeCRC = true;
};

function ballSpawner::onAdd(%this,%obj)
{
	%newcar = new WheeledVehicle() 
	{
		dataBlock = ball;
	};
	%newcar.setTransform(%obj.getTransform());
}

