//--------------------------------------
// Beretta 92f
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(Beretta92FireSound)
{
   filename    = "~/data/sound/P38fire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Beretta92SwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(Beretta92DryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DebrisData(beretta92shell)
{
   shapeFile = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};
//------------------
//   ammo
//------------------
datablock ItemData(Beretta92ammo)
{
	className = Ammo;

	shapeFile = "~/data/shapes/weapons/colt45Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some 9mm rounds";
	computeCRC = true;
};

datablock ItemData(Beretta92Clip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/colt45Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some Beretta 92f clips";
	computeCRC = true;
	maxInventory = 6;
};
/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(Beretta92_noclip)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/Beretta92.dts";
	image = Beretta92_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty Beretta 92f";
	computeCRC = true;
	emap = true;
	packImage = Beretta92_noclipPackImage;
	slot = $PistolSlot;
	emptyItem	= Beretta92_noclip;
	fullItem = Beretta92;
};
datablock ShapeBaseImageData(Beretta92_noclipPackImage)
{
	// Basic Item properties
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/Beretta92.dts";
	emap = true;
	mountPoint = 2;
	offset = "0.07 -0.05 0";
	rotation = eulerToMatrix( "-90 0 0" );
	//eyeOffset = "0.1 0.2 -0.55";
};
datablock ShapeBaseImageData(Beretta92_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/Beretta92.dts";
	item = Beretta92_noclip;
	ammo = Beretta92ammo;
	clip = Beretta92clip;
	offset = "0 0 0";
	emap = true;
	projectile = mm9long;		
	projectileType = Projectile;	
	
	armThread = lookpistol;
	rootThread = rootpistol;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 2.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};
//function Beretta92_noclipImage::onAddClip(%this, %obj, %slot)
//{	
//	%clip = %this.clip;
//	%ammo = %this.ammo;
//	//if they have a clip
//	if( %obj.getInventory(Beretta92clip) )
//	{	
//		%obj.decInventory(Beretta92_noclip, 1);		//take the player's noclip
//		%obj.incInventory(Beretta92, 1);	//hack		//give them a regular 
//		%obj.decInventory(Beretta92clip, 1);			//take away 1  clip
//		%obj.incInventory(Beretta92ammo, 400);		//give them  rounds
//
//		//fix mounts
//		%obj.unmountImage(%slot);
//		%obj.mountImage(Beretta92Image, %slot);	//hack
//	}
//	else
//		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more Beretta 92 clips!~wfx/misc/misc.error.wav' );
//}
//function Beretta92_noclipImage::changeClip(%this, %obj, %slot)
//{	
//	%obj.decinventory(Beretta92_noclip, 1);
//	%obj.unmountImage(%slot);
//	%obj.incinventory(Beretta92_noclip, 1);
//	%obj.mountImage(Beretta92_noclipImage, %slot);		
//}

//////////
//weapon//
//////////
datablock ItemData(Beretta92)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/Beretta92.dts";
	image = Beretta92Image;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "a Beretta 92f";
	computeCRC = true;
	emap = true;
	rotation = "1 1 1 1";
	packImage = Beretta92packImage;
	slot = $PistolSlot;
	emptyItem	= Beretta92_noclip;
};
datablock ShapeBaseImageData(Beretta92packImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/beretta92.dts";
	emap = true;
	mountPoint = 2;
	offset = "0.07 -0.05 0";
	rotation = eulerToMatrix( "-90 0 0" );
};

datablock ShapeBaseImageData(Beretta92Image)
{
	accuracy = 0.01;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/Beretta92.dts";
	item = Beretta92;
	ammo = Beretta92ammo;
	clip = Beretta92clip;
	offset = "0 0 0";
	emap = true;
	projectile = mm9long;		//doesnt matter
	projectileType = Projectile;	//doesnt matter
	
	armThread = lookpistol;
	rootThread = rootpistol;


	casing              = beretta92shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = Beretta92SwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.15;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = Beretta92FireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = Beretta92DryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";
};

//function Beretta92Image::onFire(%this, %obj, %slot)
//{
//	%projectile = %this.projectile;
//
//   // Decrement inventory ammo. The image's ammo state is update
//   // automatically by the ammo inventory hooks.
//   %obj.decInventory(%this.ammo,1);
//
//   // Determin initial projectile velocity based on the 
//   // gun's muzzle point and the object's current velocity
//   %muzzleVector = %obj.getMuzzleVector(%slot);
//   %objectVelocity = %obj.getVelocity();
//   %muzzleVelocity = VectorAdd(
//      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
//      VectorScale(%objectVelocity, %projectile.velInheritFactor));
//
//   // Create the projectile object
//   %p = new (%this.projectileType)() {
//      dataBlock        = %projectile;
//      initialVelocity  = %muzzleVelocity;
//      initialPosition  = %obj.getMuzzlePoint(%slot);
//      sourceObject     = %obj;
//      sourceSlot       = %slot;
//      client           = %obj.client;
//   };
//   MissionCleanup.add(%p);
//   return %p;
//
//}
//
//function Beretta92Image::changeClip(%data, %obj, %slot)
//{
//	%obj.decInventory(Beretta92, 1);			//take away m16
//	%obj.incInventory(Beretta92_noclip, 1);		//give noclip m16
//	//throw clip debris??
//	//unmount and mount
//	%obj.unmountImage(%slot);			//unnessesary? 
//	%obj.mountImage(Beretta92_noclipImage, %slot);	//dont forget that you mount IMAGES 
//}