//*********************
//    .50 bmg round
//*********************

datablock AudioProfile(bmg50ImpactSound)
{
   filename    = "~/data/sound/pop.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DecalData(bmg50decal)
{
   sizeX       = 0.5;
   sizeY       = 0.5;
   textureName = "~/data/shapes/rifle/smokeParticle";
};


datablock DebrisData(bmg50Shell)
{
   shapeName = "~/data/shapes/weapons/45shell.dts";

   lifetime = 3.0;

   minSpinSpeed = 600.0;
   maxSpinSpeed = 800.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   scale = "2 2 2";
	
   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};      
/////////////
//explosion//
/////////////
datablock ParticleData(bmg50ExplosionParticle1)
{
	dragCoefficient		= 0.2;
	windCoefficient		= 0.2;
	gravityCoefficient	= 5.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1600;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 5.0;
	spinRandomMin		= -90.0;
	spinRandomMax		= 90.0;
	useInvAlpha		= true;
	//animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/shapes/rifle/smokeParticle";
	//animTexName		= "~/data/shapes/rifle/smokeParticle";
	colors[0] = "0.5 0.5 0.2 0.7";
	colors[1] = "0.5 0.5 0.3 0.4";
	colors[2] = "0.4 0.4 0.4 0.0";
	sizes[0]      = 1.5;
	sizes[1]      = 1;
	sizes[2]      = 1;
	times[0]      = 0.0;
	times[1]      = 0.5;
	times[2]      = 1.0;
};

datablock ParticleEmitterData(bmg50ExplosionEmitter)
{
	ejectionPeriodMS	= 10;
	periodVarianceMS	= 0;
	ejectionVelocity	= 20;
	velocityVariance	= 20;
	ejectionOffset		= 0.0;
	thetaMin		= 0;
	thetaMax		= 2;
	phiReferenceVel		= 0;
	phiVariance		= 360;
	//overrideAdvances	= true; //false;
	orientParticles		= true;
	//orientOnVelocity	= false;
	particles		= bmg50ExplosionParticle1;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 10;
	//useEmitterSizes	= false;
	//useEmitterColors	= false;
};


datablock ParticleData(bmg50ExplosionParticle2)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 000;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = true;
   colors[0] = "0.7 0.7 0.7 1.0";
   colors[1] = "0.7 0.7 0.5 .8";
   colors[2] = "0.7 0.7 0.4 0.0";
   sizes[0]      = 0.75;
   sizes[1]      = 0.5;
   sizes[2]      = 0.25;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(bmg50ExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = true; //false;
   orientParticles  = true;
   lifetimeMS       = 20;
   particles = "bmg50ExplosionParticle2";
};
datablock ExplosionData(bmg50Explosion)
{
	soundProfile   = bmg50ImpactSound;
	faceViewer = true;
	explosionScale		= 1;
	playSpeed		= 1;
	emitter[0] = bmg50ExplosionEmitter;
	emitter[1] = bmg50ExplosionEmitter2;

	delayMS			= 10;
	delayVariance		= 0;
	lifetimeMS		= 100;
	lifetimeVariance	= 0;
	offset			= 0;

	times[0]		= 0.0;
	sizes[0]		= 1.0;

	shakeCamera		= false;
	camShakeFreq		= "0.0 0.0 0.0";
	camShakeAmp		= "0.0 0.0 0.0";
	camShakeDuration	= 0;
	camShakeRadius		= 0.0;
	camShakeFalloff		= 0.0;
};
//////////////
//projectile//
//////////////
datablock ProjectileData(bmg50projectile)
{
	projectileShapeName = "~/data/shapes/weapons/bullet.dts";
   doDynamicClientHits = true;

   directDamage        = 80;
   explosion           = bmg50Explosion;
   splash              = bmg50Explosion;

   directDamageType    = $DamageType::ShrikeBlaster;
   kickBackStrength  = 0.0;

   //sound = bmg50FlightSound;
	velInheritFactor	= 1.0;
	isBallistic		= true;
	armingDelayMS		= 0;
	grenadeElasticity	= 0;
	grenadeFriction		= 1.0;
	drag			= 0.05; 
	gravityMod		= 1.0;
	muzzleVelocity    = 762.0;
	scale = "2 2 2";

   dryVelocity       = 762.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 1000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 45.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 0.0 1.0";
	tracerTex[0]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerTex[1]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerWidth     = 0.25;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;

	gravityCoefficient   = 5.0;
	gravityMod = 1.0;

	scale = "10 100 10";

	decalData[0] = bmg50decal;
};