//-----------------------------------------------------------------------------
// Projectile Explosion
/////////////
//explosion//
/////////////
datablock ParticleData(cal30ExplosionParticle1)
{
	dragCoefficient		= 5.0;
	windCoefficient		= 0.2;
	gravityCoefficient	= 1.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 5.0;
	spinRandomMin		= -90.0;
	spinRandomMax		= 90.0;
	useInvAlpha		= true;
	animateTexture		= false;
	framesPerSec		= 1;

	textureName		= "~/data/shapes/particles/spark";
//	animTexName		= "";

	colors[0] = "1.0 1.0 0.8 0.7";
	colors[1] = "1.0 1.0 0.7 0.4";
	colors[2] = "1.0 1.0 0.4 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.25;
	sizes[2]      = 0.25;
	times[0]      = 0.0;
	times[1]      = 0.5;
	times[2]      = 1.0;
};

datablock ParticleEmitterData(cal30ExplosionEmitter1)
{
	ejectionPeriodMS	= 10;
	periodVarianceMS	= 0;
	ejectionVelocity	= 10;
	velocityVariance	= 0;
	ejectionOffset		= 0.0;
	thetaMin		= 0;
	thetaMax		= 90;
	phiReferenceVel		= 0;
	phiVariance		= 360;
	overrideAdvances	= true; //false;
	orientParticles		= true;
	orientOnVelocity	= false;
	particles		= cal30ExplosionParticle1;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 10;
	useEmitterSizes		= false;
	useEmitterColors	= false;
};


datablock ParticleData(cal30ExplosionParticle2)
{
	dragCoefficient		= 15.0;
	windCoefficient		= 0.2;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 100;
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	useInvAlpha		= true;
	animateTexture		= false;
	framesPerSec		= 1;

	textureName		= "~/data/shapes/rifle/smokeParticle";
//	animTexName		= "";

	colors[0] = "0.7 0.7 0.7 1.0";
	colors[1] = "0.7 0.7 0.7 .8";
	colors[2] = "0.7 0.7 0.7 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.15;
	sizes[2]      = 0.15;
	times[0]      = 0.0;
	times[1]      = 0.5;
	times[2]      = 1.0;
};

datablock ParticleEmitterData(cal30ExplosionEmitter2)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 10;
	velocityVariance	= 0;
	ejectionOffset		= 0.0;
	thetaMin		= 80;
	thetaMax		= 90;
	phiReferenceVel		= 0;
	phiVariance		= 360;
	overrideAdvances	= true; //false;
	orientParticles		= true;
	orientOnVelocity	= false;
	particles		= cal30ExplosionParticle2;
	lifetimeMS		= 40;
	lifetimeVarianceMS	= 10;
	useEmitterSizes		= false;
	useEmitterColors	= false;
};

datablock ExplosionData(cal30Explosion)
{
//	explosionShape		= "";
	soundProfile		= cal30ImpactSound;
	faceViewer		= true;
	particleEmitter		= cal30ExplosionEmitter;
	particleDensity		= 1;
	particleRadius		= 5;
	explosionScale		= 1;
	playSpeed		= 1;

	emitter[0]		= cal30ExplosionEmitter1;
	emitter[1]		= cal30ExplosionEmitter2;
	debris			= HTRifleShell;
//	shockwave		= "";
//	shockwaveOnTerrain	= false;

	debrisThetaMin		= 0;
	debrisThetaMax		= 90;
	debrisPhiMin		= 0;
	debrisPhiMax		= 360;
	debrisNum		= 10;
	debrisNumVariance	= 0;
	debrisVelocity		= 10;
	debrisVelocityVariance	= 0;

//	subExplosion		= "";
//
//	delayMS			= 0;
//	delayVariance		= 0;
//	lifetimeMS		= 0;
//	lifetimeVariance	= 0;
//	offset			= 0;

	times[0]		= 0.0;
	sizes[0]		= 1.0;

	shakeCamera		= false;
	camShakeFreq		= "0.0 0.0 0.0";
	camShakeAmp		= "0.0 0.0 0.0";
	camShakeDuration	= 0;
	camShakeRadius		= 0.0;
	camShakeFalloff		= 0.0;

	lightStartRadius	= 0;
	lightEndRadius		= 0;
	lightStartColor		= "0.0 0.0 0.0";
	lightEndColor		= "0.0 0.0 0.0";
};

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Projectile Object

datablock ProjectileData(cal30Projectile)
{
   projectileShapeName = "~/data/shapes/rifle/projectile.dts";
   directDamage        = 20;
   radiusDamage        = 0.1;
   damageRadius        = 0.5;
   explosion           = cal30Explosion;
   //particleEmitter     = RifleSmokeEmitter;

   muzzleVelocity      = 600;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
//-----------------------------------------------------------------------------