//*********************
//    .30 caliber round
//*********************

datablock AudioProfile(cal30ImpactSound)
{
   filename    = "~/data/sound/pop.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DecalData(cal30decal)
{
   sizeX       = 0.05;
   sizeY       = 0.05;
   textureName = "~/data/shapes/rifle/smokeParticle";
};


datablock DebrisData(cal30Shell)
{
   shapeName = "~/data/shapes/weapons/45shell.dts";

   lifetimeMS = 3.0;

   minSpinSpeed = 600.0;
   maxSpinSpeed = 800.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   scale = "2 2 2";
	
   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};      
/////////////
//explosion//
/////////////
datablock ParticleData(cal30ExplosionParticle1)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = 3.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = true;
   colors[0] = "1.0 1.0 1.0 1";
   colors[1] = "0.5 0.5 0.5 0.5";
   colors[2] = "0.5 0.5 0.5 0.0";
   sizes[0]      = 0.15;
   sizes[1]      = 0.1;
   sizes[2]      = 0.01;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(cal30ExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 1;
   ejectionVelocity = 8;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 30;
   thetaMax         = 75;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = true;
   orientParticles  = true;
   lifetimeMS      = 10;
   particles = "cal30ExplosionParticle1";
};


datablock ParticleData(cal30ExplosionParticle2)	//smoke ring
{
   dragCoefficient      = 10.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 000;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = true;
   colors[0] = "0.75 0.75 0.75 0.5";
   colors[1] = "0.75 0.75 0.75 0.3";
   colors[2] = "0.75 0.75 0.75 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.15;
   sizes[2]      = 0.1;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(cal30ExplosionEmitter2)	//smoke ring
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 20;
   particles = "cal30ExplosionParticle2";
};
datablock ExplosionData(cal30Explosion)
{
	soundProfile   = cal30ImpactSound;
	//shockwave = FiftyCalHit;
	faceViewer = true;
	emitter[0] = cal30ExplosionEmitter;
	emitter[1] = cal30ExplosionEmitter2;
};
//////////////
//projectile//
//////////////
datablock ProjectileData(cal30projectile)
{
	projectileShapeName = "~/data/shapes/rifle/projectile.dts";
   doDynamicClientHits = true;

   directDamage        = 0.2;
   explosion           = "cal30Explosion";
   //splash              = ChaingunSplash;

   directDamageType    = $DamageType::ShrikeBlaster;
   kickBackStrength  = 0.0;

   //sound = cal30FlightSound;
	velInheritFactor	= 1.0;
	isBallistic		= true;
	armingDelayMS		= 0;
	grenadeElasticity	= 0;
	grenadeFriction		= 1.0;
	drag			= 0.05; 
	gravityMod		= 1.0;
	muzzleVelocity    = 200.0;
	scale = "2 2 2";

   dryVelocity       = 200.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 1000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 45.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 0.0 1.0";
	tracerTex[0]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerTex[1]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerWidth     = 0.25;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;

	gravityCoefficient   = 5.0;
	gravityMod = 1.0;
};