//--------------------------------------
// colt 45
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(colt45FireSound)
{
   filename    = "~/data/sound/coltf1.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(colt45SwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ChangeClipSound)
{
   filename    = "~/data/sound/P38reload2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(colt45DryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock DebrisData(colt45shell)
{
   shapeFile = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};
//clip debris
datablock DebrisData(colt45ClipDebris)
{
   shapeName = "~/data/shapes/weapons/colt45Clip.dts";

   lifetime = 3.0;

   minSpinSpeed = 0.0;
   maxSpinSpeed = 0.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};        

datablock ExplosionData(colt45ClipExplosion)
{
	explosionShape = "~/data/shapes/weapons/colt45Clip.dts";
	playSpeed = 1.5;
	faceViewer = true;

	emitter[0] = bloodEmitter;

	debris = colt45ClipDebris;
	debrisThetaMin = 10;
	debrisThetaMax = 80;
	debrisNum = 10;
	debrisNumVariance = 0;
	debrisVelocity = 20.0;
	debrisVelocityVariance = 5.0;

	shakeCamera = true;
	camShakeFreq = "11.0 13.0 9.0";
	camShakeAmp = "40.0 40.0 40.0";
	camShakeDuration = 0.7;
	camShakeRadius = 25.0;
};
//------------------
//   ammo
//------------------
datablock ItemData(colt45ammo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/colt45Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some Colt .45 rounds";
	computeCRC = true;
};

datablock ItemData(colt45Clip)
{
	category = "Ammo";
	className = "Ammo";
	shapeFile = "~/data/shapes/weapons/colt45Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some Colt .45 clips";
	computeCRC = true;
	maxInventory = 6;
};
//--------------------------------------
// Weapon w/ no clip
//--------------------------------------
datablock ItemData(colt45_noclip)
{
	category = "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	image = colt45_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty Colt .45";
	emap = true;
	computeCRC = true;
	packImage = colt45_noclipPackImage;
	slot = $PistolSlot;
	emptyItem	= colt45_noclip;
	fullItem = colt45;
};
datablock ShapeBaseImageData(colt45_noclipPackImage)
{
	// Basic Item properties
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	emap = true;
	mountPoint = 2;
	offset = "0.07 -0.05 0";
	rotation = eulerToMatrix( "-90 0 0" );
	//eyeOffset = "0.1 0.2 -0.55";
};
datablock ShapeBaseImageData(colt45_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	item = colt45_noclip;
	ammo = colt45ammo;
	clip = colt45clip;
	offset = "0 0 0";
	emap = true;
	projectile = acp45Long;	
	projectileType = Projectile;	
	
	armThread = lookpistol;

	casing              = acp45Shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 2.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};

//function colt45_noclipImage::onAddClip(%this, %obj, %slot)
//{	
//	%clip = %this.clip;
//	%ammo = %this.ammo;
//	//if they have a clip
//	if( %obj.getInventory(colt45clip) )
//	{	
//		%obj.decInventory(colt45_noclip, 1);		//take the player's noclipm16
//		%obj.incInventory(colt45, 1);	//hack		//give them a regular m16
//		%obj.decInventory(colt45clip, 1);			//take away 1 m16 clip
//		%obj.incInventory(colt45ammo, 400);		//give them m16 rounds
//
//		//fix mounts
//		%obj.unmountImage(%slot);
//		%obj.mountImage(colt45Image, %slot);	//hack
//	}
//	else
//		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more Colt .45 clips!~wfx/misc/misc.error.wav' );
//}
//
//function colt45_noclipImage::changeClip(%this, %obj, %slot)
//{	
//	%obj.decinventory(colt45_noclip, 1);
//	%obj.unmountImage(%slot);
//	%obj.incinventory(colt45_noclip, 1);
//	%obj.mountImage(colt45_noclipImage, %slot);		
//}


//--------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(colt45)
{
	category	= "Weapon";
	className = "Weapon";
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	image = colt45Image;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "a Colt .45";
	emap = true;
	computeCRC = true;
	packImage = colt45packImage;
	slot = $PistolSlot;
	emptyItem	= colt45_noclip;
};
datablock ShapeBaseImageData(colt45packImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	emap = true;
	mountPoint = 2;
	offset = "0.07 -0.05 0";
	rotation = eulerToMatrix( "-90 0 0" );
};
datablock ShapeBaseImageData(colt45Image)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/colt45.dts";
	item = colt45;
	ammo = colt45ammo;
	clip = colt45clip;
	offset = "0 0 0";
	emap = true;
	projectile = acp45long;		//doesnt matter
	projectileType = Projectile;	//doesnt matter
	
	armThread = lookpistol;
	rootThread = rootpistol;


	casing              = colt45shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = colt45SwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";
	//stateSound[2] = MortarIdleSound;

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.2;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = colt45FireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";			//hold trigger for 3 sec to reload
	stateSound[6] = colt45DryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";	

};


function colt45Image::Ready(%this, %obj, %slot)
{
	%obj.recoil = 0;
	
}

//function colt45Image::onFire(%this, %obj, %slot)
//{
//	%projectile = %this.projectile;
//
//   // Decrement inventory ammo. The image's ammo state is update
//   // automatically by the ammo inventory hooks.
//   %obj.decInventory(%this.ammo,1);
//
//   // Determin initial projectile velocity based on the 
//   // gun's muzzle point and the object's current velocity
//   %muzzleVector = %obj.getMuzzleVector(%slot);
//   %objectVelocity = %obj.getVelocity();
//   %muzzleVelocity = VectorAdd(
//      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
//      VectorScale(%objectVelocity, %projectile.velInheritFactor));
//
//   // Create the projectile object
//   %p = new (%this.projectileType)() {
//      dataBlock        = %projectile;
//      initialVelocity  = %muzzleVelocity;
//      initialPosition  = %obj.getMuzzlePoint(%slot);
//      sourceObject     = %obj;
//      sourceSlot       = %slot;
//      client           = %obj.client;
//   };
//   MissionCleanup.add(%p);
//   return %p;
//
//}
//
//
//function colt45Image::changeClip(%data, %obj, %slot)
//{
//	%muzzlepoint = %obj.getmuzzlepoint($WeaponSlot);
//	%obj.decInventory(colt45, 1);			//take away m16
//	%obj.incInventory(colt45_noclip, 1);		//give noclip m16
//	//throw clip debris??
//	%clip = new (explosion)() 
//	{
//		datablock = bloodexplosion;
//	};
//	echo(%slot);
//	echo(%obj.getposition(), " ", %muzzlepoint);
//	%clip.settransform(%muzzlepoint @ "0 0 0 0");
//	missionCleanup.add(%clip);
//
//	//unmount and mount
//	%obj.unmountImage(%slot);			//unnessesary? 
//	%obj.mountImage(colt45_noclipImage, %slot);	//dont forget that you mount IMAGES 
//}