$WeaponSlot	= 0;
$HeadSlot	= 1;
$HairSlot	= 2;
$PackSlot	= 3;
$PrimarySlot	= 4;
$SecondarySlot	= 5;
$PistolSlot	= 6;
$GrenadeSlot	= 8;
$MeleeSlot	= 7;

$pi = 3.1415926;

$RightHandPoint	= 0;
$LeftHandPoint	= 3;
$HeadPoint	= 4;
$BackPoint	= 1;
$RightLegPoint	= 2;
$LeftLegPoint	= 5;
$HipPoint	= 6;
 
$ItemTime	= 10000;

$hair = 'fps/data/shapes/player/hair.png';

$DriverNode	= 1;

function eulerToMatrix( %euler )
{
	%euler = VectorScale(%euler, $pi / 180);				//convert euler rotations to radians

	%matrix = MatrixCreateFromEuler(%euler);				//make a rotation matrix
	%xvec = getWord(%matrix, 3);						//get the parts of the matrix you need
	%yvec = getWord(%matrix, 4);
	%zvec = getWord(%matrix, 5);
	%ang  = getWord(%matrix, 6);						//this is in radians
	%ang = %ang * 180 / $pi;						//convert back to degrees

	%rotationMatrix = %xvec @ " " @ %yvec @ " " @ %zvec @ " " @ %ang;	//put it all together

	return %rotationMatrix;							//send it back
}

function getWords(%phrase, %start, %end)
{
	if(%start > %end)
		return;

	%returnPhrase = getWord(%phrase, %start);
	if(%start == %end)
		return %returnPhrase;

	for(%i = %start+1; %i <= %end; %i++)
	{
		%returnPhrase = %returnPhrase @ " " @ getWord(%phrase, %i);
	}

	return %returnPhrase;
}


// --------------------------------------------
// miscellaneous yet handy functions - stolen keke

function posFromTransform(%transform)
{
   // the first three words of an object's transform are the object's position
   %position = getWord(%transform, 0) @ " " @ getWord(%transform, 1) @ " " @ getWord(%transform, 2);
   return %position;
}

function rotFromTransform(%transform)
{
   // the last four words of an object's transform are the object's rotation
   %rotation = getWord(%transform, 3) @ " " @ getWord(%transform, 4) @ " " @ getWord(%transform, 5) @ " " @ getWord(%transform, 6);
   return %rotation;
}

function posFromRaycast(%transform)
{
   // the 2nd, 3rd, and 4th words returned from a successful raycast call are the position of the point
   %position = getWord(%transform, 1) @ " " @ getWord(%transform, 2) @ " " @ getWord(%transform, 3);
   return %position;
}

function normalFromRaycast(%transform)
{
   // the 5th, 6th and 7th words returned from a successful raycast call are the normal of the surface
   %norm = getWord(%transform, 4) @ " " @ getWord(%transform, 5) @ " " @ getWord(%transform, 6);
   return %norm;
}
