//---------------------------------------------
//  crate pack- deployable.  Cant have a base without at least 1100 crates
//------------------------------------------------
//Explosion!

datablock AudioProfile(crateExplosionSound)
{
   filename    = "~/data/sound/CANON3.wav";
   description = AudioClose3d;
  // preload = false;
};

datablock DebrisData(crateDebris)
{
	//texture		= "";
	//emitters		= ;
	//explosion		= ;
	elasticity		= 0.5;
	friction		= 0.5;
	numBounces		= 2;
	bounceVariance		= 1;
	minSpinSpeed		= -90;
	maxSpinSpeed		= 90;
	render2D		= false;
	shapeFile		= "~/data/shapes/items/crateDebris.dts";
	explodeOnMaxBounce	= true;
	staticOnMaxBounce	= true;
	snapOnMaxBounce		= true;
	lifetime		= 400;
	lifetimeVariance	= 100;
	velocity		= 7;
	velocityVariance	= 3;
	fade			= true;
	useRadiusMass		= false;
	baseRadius		= 1.0;
	gravModifier		= 1.0;
	terminalVelocity	= 50.0;
	ignoreWater		= false;
	//preload = false;	
};


datablock ParticleData(crateExplosionParticle1)
{
	dragCoefficient		= 0.2;
	windCoefficient		= 0.2;
	gravityCoefficient	= -0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 5.0;
	spinRandomMin		= -90.0;
	spinRandomMax		= 90.0;
	useInvAlpha		= false;
	//animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/shapes/rifle/smokeParticle";
	//animTexName		= "~/data/shapes/rifle/smokeParticle";

	colors[0]		= "0.8 0.7 0.7 0.5";
	colors[1]		= "0.8 0.7 0.3 0.0";

	sizes[0]		= 2;
	sizes[1]		= 4;

	times[0]		= 0.0;
	times[1]		= 1.0;

};

datablock ParticleEmitterData(crateExplosionEmitter1)
{
	ejectionPeriodMS	= 10;
	periodVarianceMS	= 5;
	ejectionVelocity	= 2;
	velocityVariance	= 1;
	ejectionOffset		= 0;
	thetaMin		= 0;
	thetaMax		= 90;
	phiReferenceVel		= 0;
	phiVariance		= 360;
	//overrideAdvance		= false;
	orientParticles		= false;
	//orientOnVelocity	= false;
	particles		= crateExplosionParticle1;
	lifetimeMS		= 50;
	lifetimeVarianceMS	= 10;
	//useEmitterSizes		= false;
	//useEmitterColors	= false;
};



datablock ItemData(cratePack)
{
	category	= "Deployable";
	className	= Deployable;
	staticShape	= deployedCrate;
	shapeFile	= "~/data/shapes/items/smallcrate.dts";
	image		= cratePackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a deployable crate";
	computeCRC	= true;
	emap		= false;
	maxInventory	= 5;
};
datablock ExplosionData(crateExplosion)
{
	soundProfile		= crateExplosionSound;
	explosionShape		= "fps/data/shapes/items/glue.dts";
	faceViewer		= true;
	particleEmitter		= asdf;
	particleDensity		= 10;
	particleRadius		= 1;
	explosionScale		= "1 1 1";
	playSpeed		= 1;
	
	emitter[0]		= crateExplosionEmitter1;
	debris[0]		= crateDebris;
	//shockwave		= asdf;
	//shockwaveOnTerrain	= false;

	debrisThetaMin		= 0;
	debrisThetaMax		= 90;
	debrisPhiMin		= 0;
	debrisPhiMax		= 360;
	debrisNum		= 4;
	debrisNumVariance	= 1;
	debrisVelocity		= 10;
	debrisVelocityVariance	= 5;

	//subExplosion		= asdf;

	delayMS			= 10;
	delayVariance		= 0;
	lifetimeMS		= 100;
	lifetimeVariance	= 0;
	offset			= 0;

	times[0]		= 0.0;
	sizes[0]		= "1 1 1";

	shakeCamera		= false;
	camShakeFreq		= "0.0 0.0 0.0";
	camShakeAmp		= "0.0 0.0 0.0";
	camShakeDuration	= 0;
	camShakeRadius		= 0.0;
	camShakeFalloff		= 0.0;

	hasLight		= true;
	lightStartRadius	= 10;	
	lightEndRadius		= 0;
	lightStartColor		= "1.0 0.0 0.0";
	lightEndColor		= "0.0 0.0 0.0";
};

datablock ShapeBaseImageData(cratePackImage)
{
	className = PackImage;
	item = cratePack;
	shapeFile = "~/data/shapes/items/smallcrate.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 -0.15 -0.2";
	scale = "0.5 0.5 0.5";
	rotation = eulertomatrix("0 0 0");
};


function Deployable::onPickup(%this,%obj,%user,%amount)
{
	if( !(%user.getMountedImage($PackSlot)) && %user.pack == "" && !isObject(%user.detpack))
	{
		parent::onPickup(%this,%obj,%user,%amount);
		%user.mountImage(%this.image, $PackSlot);
	}
}

function Deployable::onUse(%data,%obj)
{
	//If you're not in control of your player, bail out now
	if(%obj.client.getControlObject() != %obj)
	{
		return;
	}

	%mask =  $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType;
	%startPos = %obj.getEyeTransform();
	%eyeVec = %obj.getEyeVector();
	%endPos = VectorAdd(%startPos, VectorScale(%eyeVec, 5) );
	%searchResult = containerRayCast(%startPos, %endPos, %mask, %obj);

	if(%searchResult)
	{
		echo("search result = ", %searchresult);
		%deployPosition = posFromRaycast(%searchResult);

		%mask =  $TypeMasks::PlayerObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::VehicleObjectType;
		%startPos = %deployPosition;
		%endPos = VectorAdd(%startPos, "0 0 1.5");
		%searchResult = containerRayCast(%startPos, %endPos, %mask, 0);

		if(%searchResult)
		{
			messageclient(%obj.client, sometype, "\c2Not enough room!");
		}
		else
		{
			%deployRotation = rotFromTransform(%obj.getTransform());
			if(getWord(%eyeVec, 2) < 0)
			{
				echo("FLIP OBJECT");
				//looking down so rotate object.
				echo(%deployRotation);
				echo(getWord(%deployRotation, 0) SPC getWord(%deployRotation, 1) SPC getWord(%deployRotation, 2) SPC getWord(%deployRotation, 3));
				%deployRotation = getWord(%deployRotation, 0) SPC getWord(%deployRotation, 1) SPC getWord(%deployRotation, 2) SPC 3.1415 + getWord(%deployRotation, 3) ;
			}
			%team = %obj.client.team;
			if(%team.count[%data] >= %team.max[%data] )
			{
				messageclient(%obj.client, sometype, "\c2Limit of " @ %team.max[%data] @ "!");
				return;
			}

			%d = new StaticShape()
			{
				datablock = %data.staticShape;
			};
			%d.setTransform(%deployPosition @ " " @ %deployRotation);
			%d.team = %team;
			%d.setShapeName(" ");
			%d.playthread(0, deploy);

			%team.count[%data]++;
			%obj.decinventory(%data, 1);
			if(%obj.getinventory(%data) <= 0)
				%obj.unmountimage($packslot);
		}
	}
}

function StaticShapeData::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	%obj.setDamageLevel(%obj.getDamageLevel() + (%damage));

	if(%obj.getDamageLevel() >= %this.maxDamage)
	{	
		%obj.team.count[%this.pack] -= 1;
		%trans = %obj.getTransform();
		%exp = new (explosion)()
		{
			datablock = %this.explosion;
		};
		%exp.setTransform(%trans);
		%obj.setTransform("0 0 -999");
		%obj.delete();
	}
}



datablock StaticShapeData(deployedCrate)
{
	pack = cratePack;
   className = Station;
   shapeFile = "~/data/shapes/items/crate.dts";
   maxDamage = 150;
   destroyedLevel = 150;
   disabledLevel = 42;
   explosion      = crateExplosion;
      expDmgRadius = 8.0;
      expDamage = 0.35;
      expImpulse = 500.0;

   dynamicType = $TypeMasks::StationObjectType;
   isShielded = true;
   energyPerDamagePoint = 110;
   maxEnergy = 50;
   rechargeRate = 0.20;
   renderWhenDestroyed = false;
   doesRepair = true;

   deployedObject = true;

   cmdCategory = "DSupport";
   cmdIcon = CMDStationIcon;
   //cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
   targetNameTag = 'Deployable';
   targetTypeTag = 'Station';

   //debrisShapeName = "debris_generic_small.dts";
   debris = crateDebris;
   heatSignature = 0;
};

