//------------------------------------------------
//  det pack- one time use, drops a big time bomb
//------------------------------------------------
datablock AudioProfile(detSound)
{
   filename    = "~/data/sound/EXPLOSION4b.WAV";
   description = AudioDefault3d;
   preload = true;
};


datablock ItemData(detPack)
{
	category	= "Pack";
	className	= Pack;
	shapeFile	= "~/data/shapes/items/detpack.dts";
	image		= detPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a det pack";
	computeCRC	= true;
	emap		= false;
};

datablock ItemData(armeddetPack)
{
	className	= pack;
	shapeFile	= "~/data/shapes/items/detpack.dts";
	image		= detPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a armed det pack *BORK!*";
	computeCRC	= true;
	emap		= false;
};

function explodeDetPack(%obj)
{
	//echo("DETPACK EXPLODING");
	
	%e = new Projectile()
	{
		datablock = detProjectile;
		initialPosition = %obj.getPosition();
	};

	//%e.setTransform(%obj.getTransform());
	//%obj.playaudio(0, detSound);

	radiusDamage(%obj,%obj.getPosition(),10, 400 ,%this.radiusDamageType,0);
	radiusImpulse(%obj.getPosition(), 10, 50);

	%obj.schedule(200, delete);
}

datablock ShapeBaseImageData(detPackImage)
{
	className = PackImage;
	item = detPack;
	shapeFile = "~/data/shapes/items/detpack.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 0.0 0.0";
	rotation = eulertomatrix("90 0 0");
};

function detPack::onUse(%data,%obj)
{
	//messageall(type, "using det pack");
	%obj.decInventory(%data, 1);
	%obj.unMountImage($PackSlot);

	%muzzlepoint = Vectoradd(%obj.getposition(), "0 0 2.5");
	%muzzlevector = %obj.getEyeVector();
	%muzzlepoint = VectorAdd(%muzzlepoint, %muzzleVector);

	%muzzleVelocity = vectorAdd(%obj.getVelocity(), vectorScale(%muzzlevector, 10));

	%p = new (item)() 
	{
	      dataBlock        = armeddetpack;
	      initialVelocity  = VectorScale(%muzzlevector, 20);
	      initialPosition  = %obj.getMuzzlePoint(0);
	      sourceObject     = %obj;
	      sourceSlot       = 0;
	      client           = %obj.client;
	};
	%p.setVelocity(%muzzleVelocity);
	%p.setTransform(%muzzlepoint);
	
	
	%obj.detpack = %p;
	MissionCleanup.Add(%p);
}

//------------------------------------
//detpack Projectile and explosion
//----------------------------------

datablock ParticleData(detParticle1)
{
   dragCoefficient      = 10.0;
   gravityCoefficient   = -7.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.6 0.2 0.7";
   colors[1]     = "0.7 0.7 0.3 0.5";
   colors[2]     = "0.4 0.4 0.4 0.0";
   sizes[0]      = 4;
   sizes[1]      = 10;
   sizes[2]      = 15;
   times[0]      = 0.0;
   times[1]      = 0.4;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(detEmitter1)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 75.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 120;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "detParticle1";
   lifetimeMS       = 200;
};

datablock ParticleData(detParticle2)
{
   dragCoefficient      = 10.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.8 0.7 0.7 0.5";
   colors[1]     = "0.8 0.7 0.7 0.5";
   colors[2]     = "0.5 0.5 0.5 0.2";
   sizes[0]      = 4;
   sizes[1]      = 4;
   sizes[2]      = 7;
   times[0]      = 0.0;
   times[1]      = 0.4;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(detEmitter2)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 150.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "detParticle2";
   lifetimeMS       = 200;
};

datablock ExplosionData(detExplosion)
{
	soundProfile = detSound;
	faceViewer = false;
	emitter[0] = detEmitter1;
	emitter[1] = detEmitter2;
	
};

datablock ProjectileData(detProjectile)
{
//	projectileShapeName = "~/data/shapes/weapons/chest.dts";
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = detExplosion;
   //particleEmitter     = RifleSmokeEmitter;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;

   armingDelay         = 0;
   explodeonArm		= true;
   lifetime            = 4000;
   fadeDelay           = 2900;
   bounceElasticity    = 0.25;
   bounceFriction      = 0.5;
   //isBallistic         = true;
   //gravityMod = 1.0;

   //hasLight    = true;
   //lightRadius = 30.0;
   //lightColor  = "0 0 0.5";

};

function radiusImpulse(%position, %radius, %impulse)
{
	InitContainerRadiusSearch(%position, %radius, $TypeMasks::PlayerObjectType      |
							$TypeMasks::VehicleObjectType	|
							$TypeMasks::CorpseObjectType	|
							$TypeMasks::ItemObjectType);

	while ((%targetObject = containerSearchNext()) != 0)
	{
		//echo("TARGET = " SPC %targetObject);
		%dist = vectorLen(vectorSub(%position, %targetObject.getPosition()));
			
		%distScale = (%radius - %dist)/%radius;

		%impulseVec = vectorSub(%targetObject.getPosition(), %position);
		%impulseVec = vectorNormalize(%impulseVec);
		if(%targetObject.getDataBlock().mass)
		{
			%impulseVec = vectorScale(%impulseVec, %targetObject.getDataBlock().mass);
		}
		%impulseVec = vectorScale(%impulseVec, %impulse);

		//echo("IMPULSE = " SPC %impulsevec);
		%targetObject.applyimpulse(%targetObject.getPosition(), %impulseVec);
	}
}

function RadiusExplosion(%explosionSource, %position, %radius, %damage, %impulse, %sourceObject, %damageType)
{
   InitContainerRadiusSearch(%position, %radius, $TypeMasks::PlayerObjectType      |
                                                 $TypeMasks::VehicleObjectType     |
                                                 $TypeMasks::StaticShapeObjectType |
                                                 $TypeMasks::TurretObjectType      |
                                                 $TypeMasks::ItemObjectType);

   %numTargets = 0;
   while ((%targetObject = containerSearchNext()) != 0)
   {
	echo("TARGET = " SPC %targetObject);
      %dist = vectorLen(vectorSub(%position, %targetObject.getPosition()));

      if (%dist > %radius)
         continue;

      if (%targetObject.isMounted())
      {
         %mount = %targetObject.getObjectMount();
         %found = -1;
         for (%i = 0; %i < %mount.getDataBlock().numMountPoints; %i++)
         {
            if (%mount.getMountNodeObject(%i) == %targetObject)
            {
               %found = %i;
               break;
            }
         }
      
         if (%found != -1)
         {
            if (%mount.getDataBlock().isProtectedMountPoint[%found])
            {
               continue;
            }
         }
      }

      %targets[%numTargets]     = %targetObject;
      %targetDists[%numTargets] = %dist;
      %numTargets++;
   }

   for (%i = 0; %i < %numTargets; %i++)
   {
      %targetObject = %targets[%i];
      %dist = %targetDists[%i];

      %coverage = calcExplosionCoverage(%position, %targetObject,
                                        ($TypeMasks::InteriorObjectType |
                                         $TypeMasks::TerrainObjectType |
                                         $TypeMasks::ForceFieldObjectType |
                                         $TypeMasks::VehicleObjectType));
      if (%coverage == 0)
         continue;

      //if ( $splashTest )
         %amount = (1.0 - ((%dist / %radius) * 0.75)) * %coverage * %damage;
      //else
         //%amount = (1.0 - (%dist / %radius)) * %coverage * %damage;

      //error( "damage: " @ %amount @ " at distance: " @ %dist @ " radius: " @ %radius @ " maxDamage: " @ %damage );
      
      %data = %targetObject.getDataBlock();
      %className = %data.className;

      if (%impulse) // && %data.shouldApplyImpulse(%targetObject))
      {
         %p = %targetObject.getWorldBoxCenter();
         %momVec = VectorSub(%p, %position);
         %momVec = VectorNormalize(%momVec);
         %impulseVec = VectorScale(%momVec, %impulse * (1.0 - (%dist / %radius)));
         %doImpulse = true;
      }
      else if( %className $= WheeledVehicleData || %className $= FlyingVehicleData || %className $= HoverVehicleData )
      {
         %p = %targetObject.getWorldBoxCenter();
         %momVec = VectorSub(%p, %position);
         %momVec = VectorNormalize(%momVec);
         
         %impulseVec = VectorScale(%momVec, %impulse * (1.0 - (%dist / %radius)));
         
         if( getWord( %momVec, 2 ) < -0.5 )
            %momVec = "0 0 1";
            
         // Add obj's velocity into the momentum vector
         %velocity = %targetObject.getVelocity();
         //%momVec = VectorNormalize( vectorAdd( %momVec, %velocity) );
         %doImpulse = true;
      }
      else
      {   
         %momVec = "0 0 1";
         %doImpulse = false;
      }
      
      if(%amount > 0)
         %data.damageObject(%targetObject, %sourceObject, %position, %amount, %damageType, %momVec, %explosionSource.theClient, %explosionSource);
      else if( %explosionSource.getDataBlock().getName() $= "ConcussionGrenadeThrown" && %data.getClassName() $= "PlayerData" )
	  {
         %data.applyConcussion( %dist, %radius, %sourceObject, %targetObject );
 	  	
 	  	if(!$teamDamage && %sourceObject != %targetObject && %sourceObject.client.team == %targetObject.client.team)
 	  	{
			messageClient(%targetObject.client, 'msgTeamConcussionGrenade', '\c1You were hit by %1\'s concussion grenade.', getTaggedString(%sourceObject.client.name));
		}
	  }
      
      if( %doImpulse )
         %targetObject.applyImpulse(%position, %impulseVec);
   }
}