//---------------------------------------------
//  foundation pack- deployable.  Cant have a base without at least 1100 foundations
//------------------------------------------------

datablock ItemData(foundationPack)
{
	category	= "Deployable";
	className	= Deployable;
	staticShape	= deployedfoundation;
	shapeFile	= "~/data/shapes/items/foundationPack.dts";
	image		= foundationPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "some deployable foundations";
	computeCRC	= true;
	emap		= true;
	maxInventory	= 3;
	
};

datablock ShapeBaseImageData(foundationPackImage)
{
	className = PackImage;
	item = foundationPack;
	shapeFile = "~/data/shapes/items/foundationPack.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 -0.0 -0.0";
	scale = "0.5 0.5 0.5";
	rotation = eulertomatrix("90 0 0");
};

datablock StaticShapeData(deployedfoundation)
{
	pack = foundationPack;
	className = Station;
	shapeFile = "~/data/shapes/items/foundation.dts";
	maxDamage = 800;
	destroyedLevel = 800;
	disabledLevel = 600;
	explosion      = DeployablesExplosion;
	expDmgRadius = 8.0;
	expDamage = 0.35;
	expImpulse = 500.0;

	dynamicType = $TypeMasks::StationObjectType;
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;

	deployedObject = true;

	cmdCategory = "DSupport";
	cmdIcon = CMDStationIcon;
	//cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
	targetNameTag = 'Deployable';
	targetTypeTag = 'Station';

	//debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
};

function foundationPack::onUse(%data,%obj)
{
	%mask =  $TypeMasks::TerrainObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType;
	%startPos = %obj.getEyeTransform();
	%eyeVec = %obj.getEyeVector();
	%endPos = VectorAdd(%startPos, VectorScale(%eyeVec, 5) );
	%searchResult = containerRayCast(%startPos, %endPos, %mask, %obj);

	if(%searchResult)
	{
		echo(%searchResult.getClassname());
		if(%searchResult.getClassname() !$= "TerrainBlock" && %searchResult.getDataBlock() != nameToID(deployedfoundation) )
		{
			messageclient(%obj.client, sometype, "\c2Can only deploy on Terrain!");
			return;
		}
		
		
		%deployPosition = posFromRaycast(%searchResult);

		%mask =  $TypeMasks::PlayerObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::VehicleObjectType;
		%startPos = %deployPosition;
		%endPos = VectorAdd(%startPos, "0 0 1.5");
		%searchResult = containerRayCast(%startPos, %endPos, %mask, 0);

		if(%searchResult)
		{
			messageclient(%obj.client, sometype, "\c2Not enough room!");
		}
		else
		{
			%deployRotation = rotFromTransform(%obj.getTransform());
			%team = %obj.client.team;
			if(%team.count[%data] >= %team.max[%data] )
			{
				messageclient(%obj.client, sometype, "\c2Limit of " @ %team.max[%data] @ "!");
				return;
			}
			%x = mfloor(getword(%deployPosition, 0) + 0.5);
			%y = mfloor(getword(%deployPosition, 1) + 0.5);
			%z = mfloor(getword(%deployPosition, 2) + 0.5);

			%d = new StaticShape()
			{
				datablock = %data.staticShape;
			};
			
			%d.setTransform(%x SPC %y SPC %z SPC "0 0 1 0");
			%d.team = %team;
			%d.setShapeName(" ");
			%d.playthread(0, deploy);

			%team.count[%data]++;
			%obj.decinventory(%data, 1);
			if(%obj.getinventory(%data) <= 0)
				%obj.unmountimage($packslot);
		}
	}
}