//--------------------------------------
// glueGun secondary weapon
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(glueGunFireSound)
{
   filename    = "~/data/sound/sterlingFire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(glueGunSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(glueGunDryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

//------------------
//   ammo
//------------------
datablock ItemData(glueGunammo)
{
	category = "Ammo";
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/m16Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some .30 rounds";
	computeCRC = true;
};

datablock ItemData(glueGunClip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/m16Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some glueGun clips";
	computeCRC = true;
	scale = "2 2 2";
	maxInventory = 6;
};

/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(glueGun_noclip)
{
	category = "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	image = glueGun_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty glueGun";
	computeCRC = true;
	emap = true;
	packImage = glueGun_noclipPackImage;
	slot = $SecondarySlot;
	emptyItem = glueGun_noclip;
	fullItem = glueGun;
};
datablock ShapeBaseImageData(glueGun_noclipPackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "0.17 -0.12 0";
	rotation = eulerToMatrix( "-20 15 105" );
};
datablock ShapeBaseImageData(glueGun_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	item = glueGun_noclip;
	ammo = glueGunammo;
	clip = glueGunclip;
	offset = "0 0 0";
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 3.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};



//////////
//weapon//
//////////
datablock ItemData(glueGun)
{
	className	= Weapon;
	category = "Weapon";
	shapeFile	= "~/data/shapes/weapons/m16.dts";
	image		= glueGunImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "an glueGun";
	computeCRC	= true;
	emap		= true;
	packImage	= glueGunpackImage;
	slot		= $SecondarySlot;
	emptyItem	= glueGun_noclip;
};
datablock ShapeBaseImageData(glueGunpackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m16.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "0.17 -0.12 0";
	rotation = eulerToMatrix( "-20 15 105" );
};

datablock ShapeBaseImageData(glueGunImage)
{
	accuracy = 0.01;
	accuracyStep = 0.01;
	maxAccuracy = 0.2;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/m16.dts";
	item = glueGun;
	ammo = glueGunammo;
	clip = glueGunclip;
	offset = "0 0 0";
	emap = true;
	projectile = glueProjectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	casing              = glueGunshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = m16SwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	//stateTimeoutValue[2] = 0;
	stateScript[2] = "Ready";
	stateTransitionOnTriggerDown[2] = "Fire";
	//stateTransitionOnTimeout[2] = "Ready";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	//stateSound[2] = MortarIdleSound;

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.04;
	stateFire[3] = true;
	//stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = glueGunFireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
        stateTimeoutValue[4] = 0.01;
	stateTransitionOnTriggerUp[4] = "StopFire";
	stateTransitionOnTimeout[4] = "Fire";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = m16DryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";

	stateName[7] = "StopFire";		//prevents avoiding recoil by rapid clicking
	stateTimeoutValue[7] = 0.35;
	stateTransitionOnTimeout[7] = "Ready";
	stateAllowImageChange[7] = false;
	stateScript[7] = "onStopFire";
};

