// Projectile Object

datablock ProjectileData(glueProjectile)
{
   projectileShapeName = "~/data/shapes/rifle/projectile.dts";
   directDamage        = 10;
   radiusDamage        = 0.1;
   damageRadius        = 0.5;
   explosion           = cal30Explosion;
   //particleEmitter     = RifleSmokeEmitter;

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 20;
   lifetime            = 10000;
   fadeDelay           = 1500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.6 0.5 0.0";
};


function glueProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	%glue = new StaticShape()
	{
		datablock = deployedGlue;
	};
	%glue.setTransform(%obj.getposition() @ " 0.5 0.5 0.5 " @ (6.29 * getrandom()) - 3.14);
	%glue.team = %team;
	%glue.playthread(0, deploy);

	%glue.schedule(3000, delete);

	%obj.schedule(100, delete);
}


datablock StaticShapeData(deployedGlue)
{
boundingBox = "1.2 1.2 2.3";
	pack = cratePack;
   className = Station;
   shapeFile = "~/data/shapes/items/glue.dts";
   maxDamage = 35;
   destroyedLevel = 35;
   disabledLevel = 10;
   explosion      = crateExplosion;
      expDmgRadius = 8.0;
      expDamage = 0.35;
      expImpulse = 500.0;

   dynamicType = $TypeMasks::StationObjectType;
   isShielded = true;
   energyPerDamagePoint = 110;
   maxEnergy = 50;
   rechargeRate = 0.20;
   renderWhenDestroyed = false;
   doesRepair = true;

   deployedObject = true;

   cmdCategory = "DSupport";
   cmdIcon = CMDStationIcon;
   //cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
   targetNameTag = 'Deployable';
   targetTypeTag = 'Station';

   //debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
   heatSignature = 0;
};

