datablock ProjectileData(hookProjectile)
{
	projectileShapeName = "~/data/shapes/weapons/hook.dts";
   emitterDelay        = -1;
   directDamage        = 25;
   directDamageType    = $DamageType::hook;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //mm9FlightSound;
   velInheritFactor    = 0.0;

   explosion           = "hookExplosion";
   splash              = BlasterSplash;


	isBallistic         = false;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 100.0;

   drag = 0.05; //0.05;

   gravityMod        = 0.0;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 30;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "1 1 1";

   lifetime     = 500;

   decalData[0] = mm9decal;

};

function hookProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	//messageall(type, 'projectile collision col = %1', %col);
   // Apply damage to the object all shape base objects

	if (%col.getType() & ($TypeMasks::ShapeBaseObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::TerrainObjectType))
	{
		%obj.client.player.setHookPos(%pos);
		%len = vectorSub(%obj.client.player.getPosition(), %pos);
		%obj.client.player.setHookLen(%len);
	}
	
}


//////////
//weapon//
//////////
datablock ItemData(hook)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/hook.dts";
	image		= hookImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a grapling hook";
	computeCRC	= true;
	emap		= true;
	packImage	= hookpackImage;
	slot		= $SecondarySlot;
	emptyItem	= hook;
	fullItem	= hook;
};
datablock ShapeBaseImageData(hookpackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/hook.dts";
	emap = true;
	mountPoint = $RightLegPoint;
	offset = "0.06 0.0 -0.1";
	rotation = eulerToMatrix( "-90 0 0" );
};

datablock ShapeBaseImageData(hookImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/hook.dts";
	item = hook;
	ammo = "";
	clip = "";
	offset = "0 0 0.1";
	rotation = eulerToMatrix( "90 0 0" );
	emap = true;
	projectile = hookProjectile;		
	projectileType = Projectile;	
	
	armThread = lookpistol;


	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = hookSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTimeoutValue[1] = 0.1;
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTimeoutValue[2] = 0.35;
	stateTransitionOnTimeout[2] = "Reload";
	stateFire[2] = true;
	stateRecoil[2] = swing2h;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = hookFireSound;

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "Reload";
};

function hookImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(3, swing2h);
	Parent::onFire(%this,%obj,%slot);
}