//--------------------------------------
// knife melee weapon
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(knifeFireSound)
{
   filename    = "~/data/sound/swish2.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(knifeSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ParticleData(knifeParticle1)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.9 0.9 0.5";
   colors[1]     = "0.8 0.8 0.8 0.5";
   colors[2]     = "0.7 0.7 0.7 0.2";
   sizes[0]      = 0.25;
   sizes[1]      = 0.25;
   sizes[2]      = 0.1;
   times[0]      = 0.0;
   times[1]      = 0.9;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(knifeEmitter1)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "knifeParticle1";
   lifetimeMS       = 100;
};

datablock ExplosionData(knifeExplosion)
{
   faceViewer = false;
   emitter[0] = knifeEmitter1;
};

datablock ProjectileData(knifeProjectile)
{
	//projectileShapeName = "~/data/shapes/rifle/projectile.dts";
   emitterDelay        = -1;
   directDamage        = 25;
   directDamageType    = $DamageType::knife;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //mm9FlightSound;
   velInheritFactor    = 1.0;

   explosion           = "knifeExplosion";
   splash              = BlasterSplash;


	isBallistic         = false;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 10.0;

   drag = 0.05; //0.05;

   gravityMod        = 0.0;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 30;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "0.75 0.75 0.75";

   lifetime     = 250;

   decalData[0] = mm9decal;

};

//////////
//weapon//
//////////
datablock ItemData(knife)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/knife.dts";
	image		= knifeImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a knife";
	computeCRC	= true;
	emap		= true;
	packImage	= knifepackImage;
	slot		= $MeleeSlot;
	emptyItem	= knife_noclip;
};
datablock ShapeBaseImageData(knifepackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/knife.dts";
	emap = true;
	mountPoint = $LeftLegPoint;
	offset = "-0.05 0.0 0.05";
	rotation = eulerToMatrix( "180 0 90" );
};

datablock ShapeBaseImageData(knifeImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/knife.dts";
	item = knife;
	ammo = "";
	clip = "";
	offset = "0 0 0";
	emap = true;
	projectile = knifeProjectile;		
	projectileType = Projectile;	
	
	armThread = look;
	rootThread = root;


	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = knifeSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTimeoutValue[1] = 0.1;
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTimeoutValue[2] = 0.35;
	stateTransitionOnTimeout[2] = "Reload";
	stateFire[2] = true;
	stateRecoil[2] = swing2h;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = knifeFireSound;

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "Reload";
};

function knifeImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(3, swing2h);
	Parent::onFire(%this,%obj,%slot);
}

function knifeImage::onReady(%this, %obj, %slot)
{
	%obj.stopThread(3);
}