//--------------------------------------
// M16
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(clatchSound)
{
   filename    = "~/data/sound/clatch.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(M16FireSound)
{
   filename    = "~/data/sound/M16fireLoop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};
datablock AudioProfile(M16FireEndSound)
{
   filename    = "~/data/sound/M16fireEnd.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(m16SwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ChangeClipSound)
{
   filename    = "~/data/sound/P38reload2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(m16DryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DebrisData(m16shell)
{
   shapeFile = "~/data/shapes/weapons/rifleShell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};

//---------------
//    empty clip
//---------------
datablock ItemData(M16EmptyClip)
{
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/colt45clip.dts";
	mass = 0.7;
	elasticity = 0.2;
   friction = 1;
   pickupRadius = 0;
   maxDamage = 0.5;
	//explosion = fGrenadeExplosion;
	//underwaterExplosion = UnderwaterfGrenadeExplosion;
   //indirectDamage      = 0.4;
   //damageRadius        = 20.0;
   //radiusDamageType    = $DamageType::Crash;
   //kickBackStrength    = 2000;

   computeCRC = true;
};
datablock DebrisData(m16ClipDebris)
{
   shapeName = "~/data/shapes/weapons/m16clip.dts";

   lifetime = 3.0;

   minSpinSpeed = 0.0;
   maxSpinSpeed = 0.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};        

//------------------
//   ammo
//------------------
//bullets that are in the gun
datablock ItemData(m16ammo)
{
	className = "Ammo";
	shapeFile = "~/data/shapes/weapons/m16clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some 5.56mm rounds";
	maxInventory = 50;
	computeCRC = true;
};
//clips
datablock ItemData(m16Clip)
{
	className = "Ammo";
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/m16clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some M16 clips";
	//maxInventory = 50;
	computeCRC = true;
	maxInventory = 6;
};


//--------------------------------------
// Weapon w/ No clip
//  keep this out for a bit and it turns into the regular one
//--------------------------------------
datablock ItemData(m16_noclip)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	//pickupRadius = 2;
	pickUpName = "an empty M16";
	image = m16_noclipImage;
	packImage = m16_noclipPackImage;
	slot = $PrimarySlot;
	emptyItem	= m16_noclip;
	fullItem = m16;
};
//this image is for mounting on the player for show (ie gun on back)
datablock ShapeBaseImageData(m16_noclipPackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	emap = true;
	mountPoint = 1;
	offset = "0.13 -0.12 0";
	rotation = "1 0 0 89";
};
datablock ShapeBaseImageData(m16_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/m16_noclip.dts";
	item = m16_noclip;
	ammo = m16ammo;
	clip = m16clip;
	offset = "0 0 0.04";
	emap = true;
	projectile = mm556long;		
	projectileType = Projectile;	
	
	armThread = lookrifle;
	rootThread = rootrifle;

	casing              = m16shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 2.5;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = clatchSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
	
};

//function m16_noclipImage::onAddClip(%this, %obj, %slot)
//{	
//	%clip = %this.clip;
//	%ammo = %this.ammo;
//	//if they have a clip
//	if( %obj.getInventory(m16clip) )
//	{	
//		%obj.decInventory(m16_noclip, 1);		//take the player's noclipm16
//		%obj.incInventory(m16, 1);	//hack		//give them a regular m16
//		%obj.decInventory(m16clip, 1);			//take away 1 m16 clip
//		%obj.incInventory(m16ammo, 400);		//give them m16 rounds
//
//		//fix mounts
//		%obj.unmountImage(%slot);
//		%obj.mountImage(m16Image, %slot);	//hack
//	}
//	else
//		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more M16 clips!~wfx/misc/misc.error.wav' );
//}
//function m16_noclipImage::changeClip(%this, %obj, %slot)
//{	
//	%obj.decinventory(m16_noclip, 1);
//	%obj.unmountImage(%slot);
//	%obj.incinventory(m16_noclip, 1);
//	%obj.mountImage(m16_noclipImage, %slot);	
//}


//--------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(m16)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/m16.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	//pickupRadius = 2;
	pickUpName = "an M16";
	image = m16Image;
	packImage = m16packImage;
	slot = $PrimarySlot;
	emptyItem	= m16_noclip;
};
//this image is for mounting on the player for show (ie gun on back)

datablock ShapeBaseImageData(m16PackImage)
{
	// Basic Item properties
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m16.dts";
	emap = true;
	mountPoint = 1;
	offset = "0.13 -0.12 0";
	rotation = eulerToMatrix( "-90 0 0" );
	//eyeOffset = "0.1 0.2 -0.55";
};
datablock ShapeBaseImageData(m16Image)
{
	accuracy = 0.0;
	accuracyStep = 0.02;
	maxAccuracy = 0.10;
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/m16.dts";
	item = m16;
	ammo = m16ammo;
	clip = m16clip;
	offset = "0 0 0.04";
	emap = true;
	projectile = mm556long;		
	projectileType = Projectile;	
	
	armThread = lookrifle;
	rootThread = rootrifle;


	casing              = m16shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = m16SwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	//stateTimeoutValue[2] = 0;
	stateScript[2] = "Ready";
	stateTransitionOnTriggerDown[2] = "Fire";
	//stateTransitionOnTimeout[2] = "Ready";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	//stateSound[2] = MortarIdleSound;

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Fire";
	stateTimeoutValue[3] = 0.08;
	stateFire[3] = true;
	//stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = m16FireSound;
	stateTransitionOnTriggerUp[3] = "StopFire";
	stateTransitionOnNoAmmo[3] = "NoAmmo";
	stateWaitForTimeout[3] = true;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
        stateTimeoutValue[4] = 0.01;
	stateTransitionOnTriggerUp[4] = "StopFire";
	stateTransitionOnTimeout[4] = "Fire";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = m16DryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";

	stateName[7] = "StopFire";		//prevents avoiding recoil by rapid clicking
	stateTimeoutValue[7] = 0.5;
	stateTransitionOnTimeout[7] = "Ready";
	stateAllowImageChange[7] = false;
	stateSound[7] = M16FireEndSound;

};


function m16Image::Ready(%this, %obj, %slot)
{
	%obj.recoil = 0;
	
}

//function m16Image::onFire(%this, %obj, %slot)
//{
//	%projectile = %this.projectile;
//
//   // Decrement inventory ammo. The image's ammo state is update
//   // automatically by the ammo inventory hooks.
//   %obj.decInventory(%this.ammo,1);
//
//   // Determin initial projectile velocity based on the 
//   // gun's muzzle point and the object's current velocity
//   %muzzleVector = %obj.getMuzzleVector(%slot);
//   %objectVelocity = %obj.getVelocity();
//   %muzzleVelocity = VectorAdd(
//      VectorScale(%muzzleVector, %projectile.muzzleVelocity),
//      VectorScale(%objectVelocity, %projectile.velInheritFactor));
//
//   // Create the projectile object
//   %p = new (%this.projectileType)() {
//      dataBlock        = %projectile;
//      initialVelocity  = %muzzleVelocity;
//      initialPosition  = %obj.getMuzzlePoint(%slot);
//      sourceObject     = %obj;
//      sourceSlot       = %slot;
//      client           = %obj.client;
//   };
//   MissionCleanup.add(%p);
//   return %p;
//
//}
//
//function m16Image::changeClip(%data, %obj, %slot)
//{
//
//	%obj.recoil = 0;
//	//messageall("clientmsg", 'Changing clip... %1 %2 %3', %data, %obj, %slot);
//	if (%obj.getInventory(m16Clip))		//is there a clip?
//	{ 
//		//schedule(2500, %obj, %obj @ ".decInventory", m16Clip, 1);	//dec clips
//		//schedule(2500, %obj, %obj @ ".setInventory", m16Ammo, 15);	//add bullets
//		%obj.decInventory(m16Clip, 1);
//		%obj.setInventory(m16Ammo, 400);
//		%obj.playaudio(0, ChangeClipSound);
//			//throw empty clip debris
//		%clip = new Debris()
//		{
//			dataBlock = m16shell;
//			sourceObject = %obj;
//		};
//	
//		%rot = getwords(%obj.getTransform(), 3, 7);
//
//		//messageall("clientmsg", 'rot %1', %rot);
//		%clip.setTransform(%obj.getMuzzlePoint(%slot) @ " " @ %rot);
//		%clip.schedule(3000, "delete");
//	}
//	else
//	{
//		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more clips!~wfx/misc/misc.error.wav' );
//	}
//	
//
//	%mount = %obj.getMountedObjectNode(%slot);
//	%mount.state = 4;
//	%mount.imagestate = 4;
//	%mount.state = "Fire";
//	%mount.imagestate = "Fire";
//
//	//messageall("clientmsg", 'Mount = %1', %mount);
//
//	//else play some error sound
//	%pos = %obj.getMuzzlePoint(%slot);
//
//}	
//
//function m16Image::changeClip(%data, %obj, %slot)
//{
//	//messageall("clientmsg", 'new changeclip system');
//	
//	%obj.decInventory(m16, 1);			//take away m16
//	%obj.incInventory(m16_noclip, 1);		//give noclip m16
//	//throw clip debris??
//	//unmount and mount
//	%obj.unmountImage(%slot);			//unnessesary? 
//	%obj.mountImage(m16_noclipImage, %slot);	//dont forget that you mount IMAGES 
//}