//--------------------------------------
// m1carbine secondary weapon
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(m1carbineFireSound)
{
   filename    = "~/data/sound/swfire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(m1carbineSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(m1carbineDryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

//shells
datablock DebrisData(m1carbineshell)
{
   shapeFile = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
   scale = "2 2 2";
};
//------------------
//   ammo
//------------------
datablock ItemData(m1carbineammo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/m1carbineClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some .30 rounds";
	computeCRC = true;
};

datablock ItemData(m1carbineClip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/m1carbineClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some M1 Carbine clips";
	computeCRC = true;
	scale = "2 2 2";
	maxInventory = 6;
};

/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(m1carbine_noclip)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/m1carbine_noclip.dts";
	image = m1carbine_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty M1 Carbine";
	computeCRC = true;
	emap = true;
	packImage = m1carbine_noclipPackImage;
	slot = $SecondarySlot;
	emptyItem = m1carbine_noclip;
	fullItem = m1carbine;
};
datablock ShapeBaseImageData(m1carbine_noclipPackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m1carbine_noclip.dts";
	emap = true;
	mountPoint = 1;
	offset =  "0.15 -0.07 0";
	rotation = "1 0 0 90";
};
datablock ShapeBaseImageData(m1carbine_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/m1carbine_noclip.dts";
	item = m1carbine_noclip;
	ammo = m1carbineammo;
	clip = m1carbineclip;
	offset = "0 0 0";
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 3.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};



//////////
//weapon//
//////////
datablock ItemData(m1carbine)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/m1carbine.dts";
	image		= m1carbineImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "an M1 Carbine";
	computeCRC	= true;
	emap		= true;
	packImage	= m1carbinepackImage;
	slot		= $SecondarySlot;
	emptyItem	= m1carbine_noclip;
};
datablock ShapeBaseImageData(m1carbinepackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/m1carbine.dts";
	emap = true;
	mountPoint = 1;
	offset = "0.15 -0.07 0";
	rotation = "1 0 0 90";
};

datablock ShapeBaseImageData(m1carbineImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/m1carbine.dts";
	item = m1carbine;
	ammo = m1carbineammo;
	clip = m1carbineclip;
	offset = "0 0 0";
	emap = true;
	projectile = cal30Projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	casing              = m1carbineshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Activate";
	stateSound[0] = m1carbineSwitchSound;
	stateScaleAnimation[0] = 0.1;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.07;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = m1carbineFireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
	stateTimeoutValue[3] = 0.5;
	stateTransitionOnTriggerUp[4] = "Ready";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = m1carbineDryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";
};

