//---------------------------------------------
//  med pack- using it mounts a weapon that deals negative damage
//------------------------------------------------

datablock ItemData(medPack)
{
	category	= "Pack";
	className	= Pack;
	shapeFile	= "~/data/shapes/items/medkit.dts";
	image		= medPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a Medical Pack";
	computeCRC	= true;
	emap		= true;
};

datablock ShapeBaseImageData(medPackImage)
{
	className = PackImage;
	item = medPack;
	shapeFile = "~/data/shapes/items/medkit.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 0.0 -0.01";
	rotation = eulertomatrix("90 0 0");
};

function medPackImage::onUnmount(%this,%obj,%slot)
{
	//if you're holding the med weapon, unmount it
	if( %obj.getmountedimage($WeaponSlot) == nameToID(medweaponimage) )
	{
		%obj.unmountimage($WeaponSlot);
	}
}

function medPack::onUse(%data,%obj)
{
	//messageall(type, "using med pack");
	%obj.mountImage(medWeaponImage,$WeaponSlot);
}

//////////////
//med weapon//
//////////////
datablock ShapeBaseImageData(medWeaponImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/items/healthpatch.dts";
	//item = morphine;
	ammo = "";
	clip = "";
	offset = "0 0 0";
	emap = true;
	projectile = medProjectile;		
	projectileType = Projectile;	
	
	armThread = look;


	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = morphineSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTimeoutValue[1] = 0.1;
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTimeoutValue[2] = 0.35;
	stateTransitionOnTimeout[2] = "Reload";
	stateFire[2] = true;
	stateRecoil[2] = swing2h;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = morphineFireSound;

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "Reload";
};

function medWeaponImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(3, swing2h);

	%mask = $TypeMasks::PlayerObjectType;
	%startPos = %obj.getEyeTransform();
	%eyeVec = %obj.getEyeVector();
	%startPos = VectorAdd(%startPos, %eyeVec);
	%endPos = VectorAdd(%startPos, VectorScale(%eyeVec, 2) );
	%searchResult = containerRayCast(%startPos, %endPos, %mask, 0);
	
			
	echo(%searchResult);
	if(%searchResult)	//got nothing, repair self
	{
		%searchResult.damage(%obj,%endPos,-10,$medDamage);
		return;
	}
	else			//repair other person
	{
		%obj.damage(%obj,%endPos,-10,$medDamage);
	}
		
	
}

function medWeaponImage::onReady(%this, %obj, %slot)
{
	%obj.stopThread(3);
}