//*********************
//        5.56 mm
//*********************

datablock AudioProfile(mm556ImpactSound)
{
   filename    = "~/data/sound/impact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(mm556FlightSound)
{
   filename    = "~/data/sound/missile_projectile.WAV";
   description = AudioClose3d;
   preload = true;
};

datablock DecalData(mm556decal)
{
   sizeX       = 0.25;
   sizeY       = 0.25;
   textureName = "~/data/shapes/rifle/smokeParticle";
};

datablock DebrisData(mm556Shell)
{
   shapeName = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 600.0;
   maxSpinSpeed = 800.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 3;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
   fade = true;
};   

//////////////
//Explosions//
//////////////
datablock ParticleData(mm556ExplosionParticle1)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 500;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = false;
   colors[0] = "0.4 0.4 0.4 1.0";
   colors[1] = "0.6 0.6 0.6 1.0";
   colors[2] = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.2;
   sizes[2]      = 0.01;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};  

datablock ParticleEmitterData(mm556ExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 6;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = true; //false;
   orientParticles  = true;
   lifetimeMS       = 60;
   particles = "mm556ExplosionParticle1";
};

datablock ParticleData(mm556SmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 1.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(mm556SmokeEmitter)
{
	shapeName = "~/data/shapes/weapons/colt45clip.dts";
   ejectionPeriodMS = 16;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "mm556SmokeParticle";
   lifetimeMS       = 50;
};

datablock ExplosionData(mm556Explosion)
{
   soundProfile   = mm556ImpactSound;
   //shockwave = mm556Hit;
   faceViewer = true;
   emitter[0] = mm556ExplosionEmitter;
   emitter[1] = mm556SmokeEmitter;

     shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "5.0 5.0 5.0";
   camShakeDuration = 0.25;
   camShakeRadius = 1.0;


};

datablock ProjectileData(mm556long)
{
	projectileShapeName = "~/data/shapes/weapons/bullet.dts";
   emitterDelay        = -1;
   directDamage        = 19;
   directDamageType    = $DamageType::mm556;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = mm556FlightSound;
   velInheritFactor    = 1.0;

   explosion           = "mm556Explosion";
   splash              = BlasterSplash;
    
	isBallistic         = true;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 300.0;

   drag = 0.05; //0.05;

   gravityMod        = 1.0;

   dryVelocity       = 300.0;
   wetVelocity       = 300.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;


   tracerLength    = 20.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 0.0 1.0";
	tracerTex[0]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerTex[1]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerWidth     = 0.05;
   crossSize       = 0.05;
   crossViewAng    = 0.990;
   renderCross     = true;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "1.05 1.05 1.05";
   crossViewAng = 0.99;
   crossSize = 1.05;

   lifetimeMS     = 3000;
   blurLifetime   = 0.05;
   blurWidth      = 0.05;
   blurColor = "0.4 0.4 0.4 1.0";

   texture[0] = "~/data/shapes/rifle/smokeParticle";
   texture[1] = "~/data/shapes/rifle/smokeParticle";

   decalData[0] = mm556decal;

};

datablock ProjectileData(mm556short)
{
   doDynamicClientHits = true;

   directDamage        = 0.25;
   explosion           = "mm556Explosion";
   splash              = BlasterSplash;

   directDamageType    = $DamageType::mm556;
   kickBackStrength  = 0.0;

   sound = mm556FlightSound;

   dryVelocity       = 300;
   wetVelocity       = 300.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 1000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 0.0 1.0";
	tracerTex[0]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerTex[1]  	 = "~/data/shapes/rifle/smokeParticle";
	tracerWidth     = 0.05;
   crossSize       = 0.05;
   crossViewAng    = 0.990;
   renderCross     = true;

	gravityCoefficient   = 5.0;
	gravityMod = 1.0;

	decalData[0] = mm556decal;

};