//*********************
//        9 mm
//*********************

datablock AudioProfile(mm9ImpactSound)
{
   filename    = "~/data/sound/impact1.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DecalData(mm9decal)
{
   sizeX       = 0.05;
   sizeY       = 0.05;
   textureName = "~/data/shapes/rifle/smokeParticle";
};

datablock DebrisData(mm9Shell)
{
   shapeName = "~/data/shapes/weapons/45shell.dts";

   lifetime = 3.0;

   minSpinSpeed = 600.0;
   maxSpinSpeed = 800.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};      

//explosion
datablock ParticleData(mm9ExplosionParticle1)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 400;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = false;
   colors[0] = "0.4 0.4 0.4 1.0";
   colors[1] = "0.4 0.4 0.4 1.0";
   colors[2] = "0.4 0.4 0.4 0.0";
   sizes[0]      = 0.05;
   sizes[1]      = 0.05;
   sizes[2]      = 0.01;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(mm9ExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = true; //false;
   orientParticles  = true;
   lifetimeMS       = 40;
   particles = "mm9ExplosionParticle1";
};

datablock ParticleData(mm9SmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.25;
   sizes[2]      = 0.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(mm9SmokeEmitter)
{
   ejectionPeriodMS = 16;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "mm9SmokeParticle";
   lifetimeMS       = 50;
};

datablock ExplosionData(mm9Explosion)
{
   soundProfile   = mm9ImpactSound;
   //shockwave = mm9Hit;
   faceViewer = true;
   emitter[0] = mm9ExplosionEmitter;
   emitter[1] = mm9SmokeEmitter;
};

datablock ProjectileData(mm9long)
{
	projectileShapeName = "~/data/shapes/weapons/bullet.dts";
   emitterDelay        = -1;
   directDamage        = 10;
   directDamageType    = $DamageType::mm9;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //mm9FlightSound;
   velInheritFactor    = 1.0;

   explosion           = "mm9Explosion";
   splash              = BlasterSplash;


	isBallistic         = true;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 150.0;

   drag = 0.05; //0.05;

   gravityMod        = 1.0;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "0.75 0.75 0.75";
   crossViewAng = 0.99;
   crossSize = 0.05;

   lifetimeMS     = 3000;
   blurLifetime   = 0.05;
   blurWidth      = 0.05;
   blurColor = "0.4 0.4 0.4 1.0";

   texture[0] = "~/data/shapes/rifle/smokeParticle";
   texture[1] = "~/data/shapes/rifle/smokeParticle";

   decalData[0] = mm9decal;

};