//--------------------------------------
// morphine secondary weapon
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(morphineFireSound)
{
   filename    = "~/data/sound/swish2.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(morphineSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ParticleData(morphineParticle1)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.9 0.9 0.5";
   colors[1]     = "0.8 0.8 0.8 0.5";
   colors[2]     = "0.7 0.7 0.7 0.2";
   sizes[0]      = 0.25;
   sizes[1]      = 0.25;
   sizes[2]      = 0.1;
   times[0]      = 0.0;
   times[1]      = 0.9;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(morphineEmitter1)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "morphineParticle1";
   lifetimeMS       = 100;
};

datablock ExplosionData(morphineExplosion)
{
   faceViewer = false;
   emitter[0] = morphineEmitter1;
};

datablock ProjectileData(morphineProjectile)
{
	//projectileShapeName = "~/data/shapes/rifle/projectile.dts";
   emitterDelay        = -1;
   directDamage        = 25;
   directDamageType    = $DamageType::morphine;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //mm9FlightSound;
   velInheritFactor    = 1.0;

   explosion           = "morphineExplosion";
   splash              = BlasterSplash;


	isBallistic         = false;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 10.0;

   drag = 0.05; //0.05;

   gravityMod        = 0.0;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 30;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "0.75 0.75 0.75";

   lifetime     = 250;

   decalData[0] = mm9decal;

};

//////////
//weapon//
//////////
datablock ItemData(morphine)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/items/morphine.dts";
	image		= morphineImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a morphine syringe";
	computeCRC	= true;
	emap		= true;
	packImage	= morphinepackImage;
	slot		= $SecondarySlot;
	emptyItem	= morphine_noclip;
};
datablock ShapeBaseImageData(morphinepackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/items/morphine.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "-0.18 0.06 0.1";
	rotation = eulerToMatrix( "0 35 35" );
};

datablock ShapeBaseImageData(morphineImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/items/morphine.dts";
	item = morphine;
	ammo = "";
	clip = "";
	offset = "0 0.1 0.03";
	emap = false;
	rotation = eulertomatrix("90 0 0");
	//projectile = ""; morphineProjectile;		
	projectileType = Projectile;	
	
	armThread = lookpistol;


	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = morphineSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateTimeoutValue[1] = 0.1;
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTimeoutValue[2] = 0.35;
	stateTransitionOnTimeout[2] = "Reload";
	stateFire[2] = true;
	stateRecoil[2] = swing2h;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = morphineFireSound;

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "Reload";
};

function morphineImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(3, swing2h);
	Parent::onFire(%this,%obj,%slot);
}

function morphineImage::onReady(%this, %obj, %slot)
{
	%obj.stopThread(3);
}