//--------------------------------------
// mp5 secondary weapon
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(mp5FireSound)
{
   filename    = "~/data/sound/sterlingFire.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(mp5SwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(mp5DryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

//shells
datablock DebrisData(mp5shell)
{
   shapeFile = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
   scale = "2 2 2";
};
//------------------
//   ammo
//------------------
datablock ItemData(mp5ammo)
{
	category = "Ammo";
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/mp5Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some .30 rounds";
	computeCRC = true;
};

datablock ItemData(mp5Clip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/mp5Clip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some MP5 clips";
	computeCRC = true;
	scale = "2 2 2";
	maxInventory = 6;
};

/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(mp5_noclip)
{
	category = "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/mp5_noclip.dts";
	image = mp5_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty MP5";
	computeCRC = true;
	emap = true;
	packImage = mp5_noclipPackImage;
	slot = $SecondarySlot;
	emptyItem = mp5_noclip;
	fullItem = mp5;
};
datablock ShapeBaseImageData(mp5_noclipPackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/mp5_noclip.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "0.17 -0.14 0";
	rotation = eulerToMatrix( "-20 15 105" );
};
datablock ShapeBaseImageData(mp5_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/mp5_noclip.dts";
	item = mp5_noclip;
	ammo = mp5ammo;
	clip = mp5clip;
	offset = "0 0 0";
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 3.0;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};



//////////
//weapon//
//////////
datablock ItemData(mp5)
{
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/mp5.dts";
	image		= mp5Image;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "an MP5";
	computeCRC	= true;
	emap		= true;
	packImage	= mp5packImage;
	slot		= $SecondarySlot;
	emptyItem	= mp5_noclip;
};
datablock ShapeBaseImageData(mp5packImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/mp5.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "0.17 -0.14 0";
	rotation = eulerToMatrix( "-20 15 105" );
};

datablock ShapeBaseImageData(mp5Image)
{
	accuracy = 0.01;
	accuracyStep = 0.01;
	maxAccuracy = 0.2;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/mp5.dts";
	item = mp5;
	ammo = mp5ammo;
	clip = mp5clip;
	offset = "0 0 0";
	emap = true;
	projectile = mm9long;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	casing              = mp5shell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateSound[0] = m16SwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	//stateTimeoutValue[2] = 0;
	stateScript[2] = "Ready";
	stateTransitionOnTriggerDown[2] = "Fire";
	//stateTransitionOnTimeout[2] = "Ready";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	//stateSound[2] = MortarIdleSound;

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.04;
	stateFire[3] = true;
	//stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = mp5FireSound;

	stateName[4] = "Reload";
	stateTransitionOnNoAmmo[4] = "NoAmmo";
	stateAllowImageChange[4] = false;
        stateTimeoutValue[4] = 0.01;
	stateTransitionOnTriggerUp[4] = "StopFire";
	stateTransitionOnTimeout[4] = "Fire";
	stateSequence[4] = "Reload";

	stateName[5] = "NoAmmo";
	stateTransitionOnAmmo[5] = "Reload";
	stateSequence[5] = "Empty";
	stateTransitionOnTriggerDown[5] = "DryFire";

	stateName[6] = "DryFire";
	stateSound[6] = m16DryFireSound;
	stateTransitionOnTriggerUp[6] = "NoAmmo";

	stateName[7] = "StopFire";		//prevents avoiding recoil by rapid clicking
	stateTimeoutValue[7] = 0.35;
	stateTransitionOnTimeout[7] = "Ready";
	stateAllowImageChange[7] = false;
	stateScript[7] = "onStopFire";
};

