datablock AudioProfile(p51LandingSound)
{
   filename    = "~/data/sound/landing.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(contrailParticle)
{
   textureName          = "~/data/shapes/vehicles/dustParticle";
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 0;
   colors[0]     = "0.4 0.4 0.4 1.0";
   colors[1]     = "0.4 0.4 0.4 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 1.0;
   times[0]	 = 0.0;
   times[1]	 = 1.0;
};

datablock ParticleEmitterData(contrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "contrailParticle";
};


datablock ParticleData(p51SmokeParticle1)
{
   textureName          = "~/data/shapes/vehicles/dustParticle";
   useInvAlpha		= true;
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   colors[0]     = "0.7 0.7 0.7 1.0";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 3.0;
   sizes[1]      = 8.0;
   times[0]	 = 0.0;
   times[1]	 = 1.0;
};

datablock ParticleEmitterData(p51SmokeEmitter1)
{
   ejectionPeriodMS = 200;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   offsetVariance   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "p51SmokeParticle1";
};

datablock ParticleData(p51SmokeParticle2)
{
   textureName          = "~/data/shapes/vehicles/dustParticle";
   useInvAlpha		= true;
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   colors[0]     = "0.2 0.2 0.2 1.0";
   colors[1]     = "0.4 0.4 0.4 0.0";
   sizes[0]      = 3.0;
   sizes[1]      = 8.0;
   times[0]	 = 0.0;
   times[1]	 = 1.0;
};

datablock ParticleEmitterData(p51SmokeEmitter2)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   offsetVariance   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "p51SmokeParticle2";
};

datablock ParticleData(p51SmokeParticle3)
{
   textureName          = "~/data/particles/bubbles";
   useInvAlpha		= true;
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   colors[0]     = "0.0 0.7 0.9 1.0";
   colors[1]     = "0.0 0.7 0.9 0.0";
   sizes[0]      = 3.0;
   sizes[1]      = 4.0;
   times[0]	 = 0.0;
   times[1]	 = 1.0;
};

datablock ParticleEmitterData(p51SmokeEmitter3)
{
   ejectionPeriodMS = 50;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   offsetVariance   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "p51SmokeParticle3";
};


datablock FlyingVehicleData(p51Air)
{
	correctMuzzleVector = False;
	displayname = " ";
	spawnOffset = "0 0 0";
	stallSpeed = "30";
	takeoffSpeed = "40";
	catagory = "Vehicles";
	shapeFile = "~/data/shapes/vehicles/p51air.dts";
	multipassenger = false;
	computeCRC = true;
	debrisShapeName = "~/data/shapes/vehicles/p51air.dts";
	debris = ShapeDebris;
	renderWhenDestroyed = false;
	drag    = 0.15;
	density = 1.0;
	mountPose[0] = sitting;
	numMountPoints = 1;
	isProtectedMountPoint[0] = true;
	cameraRoll = true;  
	cameraMaxDist = 15;
	cameraOffset = 2.5;
	cameraLag = 0.0;
	cameraDecay = 0.75; 
	explosion = ScoutFlyerExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;
	maxDamage = 200.00;
	destroyedLevel = 200.00;
	isShielded = false;
	energyPerDamagePoint = 160;
	maxEnergy = 280;      // Afterburner and any energy weapon pool
	minDrag = 80;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
	rotationalDrag = 10;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
	rechargeRate = 0.0;
	maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
	autoAngularForce = 15;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
	autoLinearForce = 15;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
	autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
	// Maneuvering
	maxSteeringAngle = 3.5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
	horizontalSurfaceForce = 10;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce = 100;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
	maneuveringForce = 6000;      // Horizontal jets (W,S,D,A key thrust)
	mainThrustForce    = 5000;
	reverseThrustForce = 20;
	steeringForce = 1500;         // Steering jets (force applied when you move the mouse)
	steeringRollForce = 18000;      // Steering jets (how much you heel over when you turn)
	rollForce = 100;                // Auto-roll (self-correction to right you after you roll/invert)
	hoverHeight = 2;        // Height off the ground at rest
	createHoverHeight = 3;  // Height off the ground when created
	//maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
	//horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	//verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
	//maneuveringForce = 2500;      // Horizontal jets (W,S,D,A key thrust)
	//steeringForce = 1200;         // Steering jets (force applied when you move the mouse)
	//steeringRollForce = 400;      // Steering jets (how much you heel over when you turn)
	//rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
	//hoverHeight = 5;        // Height off the ground at rest
	//createHoverHeight = 3;  // Height off the ground when created
	// Rigid body
	mass = 200;        // Mass of the vehicle
	bodyFriction = 0;     // Don't mess with this.
	bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
	minRollSpeed = 0;     // Don't mess with this.
	minImpactSpeed = 1;      // If hit ground at speed above this then it's an impact. Meters/second
	softImpactSpeed = 10;       // Sound hooks. This is the soft hit.
	hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.
	speedDamageScale = 2.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 45;
	//
	minTrailSpeed = 15;      // The speed your contrail shows up at.
	trailEmitter = contrailEmitter;
	forwardJetEmitter = ScoutFlyerEmitter;
	downJetEmitter = ScoutFlyerEmitter;
	//
	jetSound = ScoutFlyerThrustSound;
	engineSound = ScoutFlyerEngineSound;
	softImpactSound = SoftImpactSound;
	hardImpactSound = HardImpactSound;
	//wheelImpactSound = WheelImpactSound;
	//
	softSplashSoundVelocity = 15.0;
	mediumSplashSoundVelocity = 30.0;
	hardSplashSoundVelocity = 60.0;
	exitSplashSoundVelocity = 20.0;
	exitingWater      = VehicleExitWaterMediumSound;
	impactWaterEasy   = VehicleImpactWaterSoftSound;
	impactWaterMedium = VehicleImpactWaterMediumSound;
	impactWaterHard   = VehicleImpactWaterMediumSound;
	waterWakeSound    = VehicleWakeMediumSplashSound;
	dustEmitter = VehicleLiftoffDustEmitter;
	triggerDustHeight = 4.0;
	dustHeight = 1.0;
	damageEmitter[0] = p51SmokeEmitter1;
	damageEmitter[1] = p51SmokeEmitter2;
	damageEmitter[2] = p51SmokeEmitter3;
	damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
	damageEmitterOffset[1] = "0.0 -3.0 0.0 ";
	damageLevelTolerance[0] = 0.3;
	damageLevelTolerance[1] = 0.7;
	numDmgEmitterAreas = 3;
	//
	max[chaingunAmmo] = 1000;
	maxinv[p51ammo] = 1000;
	minMountDist = 4;
	splashEmitter[0] = VehicleFoamDropletsEmitter;
	splashEmitter[1] = VehicleFoamEmitter;
	shieldImpact = VehicleShieldImpact;
	checkRadius = 5.5;
	observeParameters = "1 10 10";
};

function p51Air::onAdd(%this,%obj)
{
	%obj.playthread(0, ambient);
	%obj.mountImage(p51gunPairImage, 0);
	%obj.mountImage(p51gunImage, 1);
	%obj.setShapeName(" ");
}

function p51Air::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	%obj.setDamageLevel(%obj.getDamageLevel() + (%damage));

	if(%obj.getDamageLevel() >= %this.maxDamage)
	{	
		%newVehicle = new WheeledVehicle()
		{
			datablock = p51Crash;
		};
		%newVehicle.setTransform(%obj.getTransform());
		%newVehicle.mountObject(%obj.getMountedObject(0), 0); 
		%newVehicle.applyImpulse( %newVehicle.getPosition(), vectorScale(%obj.getVelocity(), %newVehicle.getDataBlock().mass) );
		
		%newVehicle.setInventory(p51ammo, %obj.getInventory(p51ammo) );

			//start burning the pilot
		if(%newVehicle.getMountedObject(0))
			burn(%newVehicle.getMountedObject(0), 10, 500);

		%obj.setTransform("0 0 0 0 0 1 0");
		%obj.schedule(100, delete);
	}
}


function landCheck(%vehicle, %tick)
{

	echo("land check");
//	if(VectorLen(%vehicle.getVelocity()) < 30)
//	{
//		messageAll('clientmsg', "LAND!!");
//		%newVehicle = new WheeledVehicle()
//		{
//			datablock = p51Land;
//			initialPosition = %vehicle.getPosition();
//			initialVelocity = %vehicle.getVelocity();
//			sourceobject = %vehicle;
//		};
//		%newVehicle.setTransform(%vehicle.getTransform());
//		%newVehicle.mountObject(%vehicle.getMountedObject(0), 0); 
//		%newVehicle.setDamageLevel(%vehicle.getDamageLevel());
//		%newVehicle.applyImpulse( %newVehicle.getPosition(), vectorScale(%vehicle.getVelocity(), %newVehicle.getDataBlock().mass) );
//		
//		%newVehicle.setInventory(p51ammo, %vehicle.getInventory(p51ammo) );
//
//		%newVehicle.playAudio(0, p51LandingSound);
//
//		%vehicle.delete();
//		return;
//	}
//
//	schedule(%tick, 0, landCheck, %vehicle, %tick);
//	
}

function p51Air::onStall(%this, %obj)
{
	//messageAll('clientmsg', "LAND!!");
	//echo("STALLING" @ " " @ %obj);
	%mountedobject = %obj.getMountedObject(0);
	%transform = %obj.getTransform();
	%newVehicle = new WheeledVehicle()
	{
		datablock = p51Land;
		initialPosition = %obj.getPosition();
		initialVelocity = %obj.getVelocity();
		sourceobject = %obj;
	};
	%newVehicle.setTransform(%transform);
	%newVehicle.mountObject(%mountedobject, 0); 
	%obj.setTransform("0 0 0 0 0 1 0");
	%newVehicle.setDamageLevel(%obj.getDamageLevel());
	%newVehicle.applyImpulse( %newVehicle.getPosition(), vectorScale(%obj.getVelocity(), %newVehicle.getDataBlock().mass) );
	
	%newVehicle.setInventory(p51ammo, %obj.getInventory(p51ammo) );

	%newVehicle.playAudio(0, p51LandingSound);

	
	%obj.schedule(500,delete);


}