datablock AudioProfile(p51gunFireSound)
{
   filename    = "~/data/sound/ak47Fire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ItemData(p51ammo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/chest.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some .50 belts for the P51";
	computeCRC = true;
};

datablock ShapeBaseImageData(p51gunPairImage)
{
	correctMuzzleVector = false;
	accuracy = 0.025;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/m16.dts";
	item = p51ammo;
	ammo = p51ammo;
	clip = p51ammo;
	offset = "1.93 0.55 1.1";
	rotation = eulertomatrix("0 -90 0");
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = looksn;

	casing              = HTrifleshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 0.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.01;
	stateSequence[0] = "Full";
	stateSound[0] = HTrifleSwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "LFire";

	stateName[3] = "LFire";
	stateEjectShell[3]      = true;
	stateSequence[3] = "LFire";
	stateTransitionOnTimeout[3] = "RFire";
	stateTimeoutValue[3] = 0.04;
	//stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = p51gunFireSound;

	stateName[4] = "checkState";
	stateTransitionOnNoAmmo[4] = "EmptySpinDown";
	stateTransitionOnTriggerUp[4] = "Ready";
	stateTimeoutValue[4] = 0.01;
	stateFire[4] = false;
	stateTransitionOnTimeout[4]   = "ready";

	stateName[5] = "EmptySpinDown";
	stateTransitionOnTimeout[5] = "NoAmmo";
	stateTimeoutValue[5] = 0.25;
	stateSequence[5] = "Full";
	stateSound[5] = HTrifleSwitchSound;

	stateName[6] = "NoAmmo";
	stateTransitionOnAmmo[6] = "Reload";
	stateSequence[6] = "Empty";
	stateTransitionOnTriggerDown[6] = "DryFire";

	stateName[7] = "DryFire";
	stateSound[7] = HTrifleDryFireSound;
	stateTransitionOnTriggerUp[7] = "NoAmmo";

	stateName[8] = "RFire";
	stateEjectShell[8]      = true;
	stateSequence[8] = "RFire";
	stateTransitionOnTimeout[8] = "checkState";
	stateTimeoutValue[8] = 0.04;
	stateFire[8] = false;
	stateAllowImageChange[8] = false;
	stateScript[8] = "onPairFire";
	stateSound[8] = "";
};

datablock ShapeBaseImageData(p51gunImage) 
{
	correctMuzzleVector = false;
	accuracy = 0.025;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/m16.dts";
	item = p51ammo;
	ammo = p51ammo;
	clip = p51ammo;
	offset = "-1.93 0.55 1.1";
	rotation = eulertomatrix("0 90 0");
	emap = true;
	projectile = bmg50projectile;		
	projectileType = Projectile;	
	
	armThread = looksn;

	casing              = HTrifleshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 0.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.01;
	stateSequence[0] = "Full";
	stateSound[0] = HTrifleSwitchSound;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "LFire";

	stateName[3] = "LFire";
	stateEjectShell[3]      = true;
	stateSequence[3] = "LFire";
	stateTransitionOnTimeout[3] = "Ready";
	stateTimeoutValue[3] = 0.04;
	//stateFire[3] = true;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = p51gunFireSound;

	stateName[4] = "checkState";
	stateTransitionOnNoAmmo[4] = "EmptySpinDown";
	stateTransitionOnTriggerUp[4] = "Ready";
	stateTimeoutValue[4] = 0.01;
	stateFire[4] = false;
	stateTransitionOnTimeout[4]   = "ready";

	stateName[5] = "EmptySpinDown";
	stateTransitionOnTimeout[5] = "NoAmmo";
	stateTimeoutValue[5] = 0.25;
	stateSequence[5] = "Full";
	stateSound[5] = HTrifleSwitchSound;

	stateName[6] = "NoAmmo";
	stateTransitionOnAmmo[6] = "Reload";
	stateSequence[6] = "Empty";
	stateTransitionOnTriggerDown[6] = "DryFire";

	stateName[7] = "DryFire";
	stateSound[7] = HTrifleDryFireSound;
	stateTransitionOnTriggerUp[7] = "NoAmmo";

	stateName[8] = "RFire";
	stateEjectShell[8]      = true;
	stateSequence[8] = "RFire";
	stateTransitionOnTimeout[8] = "checkState";
	stateTimeoutValue[8] = 0.04;
	stateFire[8] = false;
	stateAllowImageChange[8] = false;
	stateScript[8] = "";
	stateSound[8] = "";
};

function p51gunPairImage::onPairFire(%this, %obj, %slot)
{
	//messageall(asdf, "LEFT SHOOT");
	%obj.setImageTrigger(1, true);
	//parent::onFire(%this, %obj, %slot);
}
