//---------------------------------------------
//  plat pack- deployable.  Cant have a base without at least 1100 plats
//------------------------------------------------

datablock ItemData(platPack)
{
	category	= "Deployable";
	className	= Deployable;
	staticShape	= deployedplat;
	shapeFile	= "~/data/shapes/items/platPack.dts";
	image		= platPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "some deployable plats";
	computeCRC	= true;
	emap		= true;
	maxInventory	= 5;
};

datablock ShapeBaseImageData(platPackImage)
{
	className = PackImage;
	item = platPack;
	shapeFile = "~/data/shapes/items/platPack.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 -0.0 -0.1";
	scale = "0.5 0.5 0.5";
	rotation = eulertomatrix("0 0 0");
};

datablock StaticShapeData(deployedplat)
{
	pack = platPack;
	className = Station;
	shapeFile = "~/data/shapes/items/plat.dts";
	maxDamage = 300;
	destroyedLevel = 300;
	disabledLevel = 150;
	explosion      = DeployablesExplosion;
	expDmgRadius = 8.0;
	expDamage = 0.35;
	expImpulse = 500.0;

	dynamicType = $TypeMasks::StationObjectType;
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;

	deployedObject = true;

	cmdCategory = "DSupport";
	cmdIcon = CMDStationIcon;
	//cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
	targetNameTag = 'Deployable';
	targetTypeTag = 'Station';

	//debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
};

