//---------------------------------------------
//  repair pack- using it mounts a weapon that deals negative damage
//------------------------------------------------

datablock ItemData(repairPack)
{
	category	= "Pack";
	className	= Pack;
	shapeFile	= "~/data/shapes/weapons/chest.dts";
	image		= repairPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "a Repair Pack";
	computeCRC	= true;
	emap		= true;
};

datablock ShapeBaseImageData(repairPackImage)
{
	className = PackImage;
	item = repairPack;
	shapeFile = "~/data/shapes/weapons/chest.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 0.0 -0.01";
	rotation = eulertomatrix("90 0 0");
};

function repairPackImage::onUnmount(%this,%obj,%slot)
{
	//if you're holding the repair weapon, unmount it
	if( %obj.getmountedimage($WeaponSlot) == nameToID(repairweaponimage) )
	{
		%obj.unmountimage($WeaponSlot);
	}
}

function repairPack::onUse(%data,%obj)
{
	messageall(type, "using repair pack");
	%obj.mountImage(repairWeaponImage,$WeaponSlot);
}

//////////////
//repair weapon//
//////////////
datablock ShapeBaseImageData(repairWeaponImage)
{
	className = "WeaponImage";
	shapeFile = "~/data/shapes/items/healthpatch.dts";
	//item = morphine;
	ammo = "";
	clip = "";
	offset = "0 0 0";
	emap = true;
	projectile = repairProjectile;		
	projectileType = Projectile;	
	
	armThread = look;


	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = morphineSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;
	stateTimeoutValue[1] = 0.1;
	stateScript[1] = "onReady";

	stateName[2] = "Fire";
	stateTimeoutValue[2] = 0.35;
	stateTransitionOnTimeout[2] = "Reload";
	stateFire[2] = true;
	stateRecoil[2] = swing2h;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = morphineFireSound;

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTimeoutValue[3] = 0.1;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "Reload";
};

function repairWeaponImage::onFire(%this, %obj, %slot)
{
	%obj.playThread(3, swing2h);

	%mask = $TypeMasks::VehicleObjectType | $TypeMasks::StaticObjectType;
	%startPos = %obj.getEyeTransform();
	%eyeVec = %obj.getEyeVector();
	%startPos = VectorAdd(%startPos, %eyeVec);
	%endPos = VectorAdd(%startPos, VectorScale(%eyeVec, 2) );
	%searchResult = containerRayCast(%startPos, %endPos, %mask, 0);
	
			
	echo(%searchResult);
	if(%searchResult)	
	{
		%searchResult.damage(%obj,%endPos,-25,$repairDamage);
	}
	else
	{
		//fix your own stuff??
	}
	
	
}

function repairWeaponImage::onReady(%this, %obj, %slot)
{
	%obj.stopThread(3);
}



