//--------------------------------------
// Shotgun!
//--------------------------------------

//-------------
//   audio
//-----------
datablock AudioProfile(shotgunFireSound)
{
   filename    = "~/data/sound/shotgunfire1.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(shotgunSwitchSound)
{
   filename    = "~/data/sound/38select.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(shotgunCockSound)
{
   filename    = "~/data/sound/shotgunrechamber1.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock AudioProfile(shotgunDryFireSound)
{
   filename    = "~/data/sound/Dryfire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DebrisData(shotgunshell)
{
   shapeFile = "~/data/shapes/weapons/45shell.dts";
   lifetime = 3.0;
   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 4;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
};
//------------------
//   ammo
//------------------
datablock ItemData(shotgunammo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/shotgunClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some 12ga rounds";
	computeCRC = true;
};

datablock ItemData(shotgunClip)
{
	className = Ammo;
	category = "Ammo";
	shapeFile = "~/data/shapes/weapons/shotgunClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some Shotgun Shells";
	computeCRC = true;
	maxInventory = 50;
};
/////////////////////
//weapon w/ no clip//
/////////////////////
datablock ItemData(shotgun_noclip)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	image = shotgun_noclipImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "an empty Shotgun";
	computeCRC = true;
	emap = true;
	packImage = shotgun_noclipPackImage;
	slot = $SecondarySlot;
	emptyItem	= shotgun_noclip;
	fullItem = shotgun;
	
};
datablock ShapeBaseImageData(shotgun_noclipPackImage)
{
	// Basic Item properties
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.07 -0.05 0";
	rotation = eulerToMatrix( "-90 0 0" );
	//eyeOffset = "0.1 0.2 -0.55";
};
datablock ShapeBaseImageData(shotgun_noclipImage)
{
	className = WeaponImage;
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	item = shotgun_noclip;
	ammo = shotgunammo;
	clip = shotgunclip;
	offset = "0 0 0";
	emap = true;
	projectile = mm9long;		
	projectileType = Projectile;	
	
	armThread = lookrifle;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "AddClip";
	stateTimeoutValue[0] = 0.15;
	stateAllowImageChange[0] = True;
	//stateSequence[0] = "Full";
	stateSound[0] = ChangeClipSound;

	stateName[1] = "AddClip";
	stateAllowImageChange[1] = True;
	stateScript[1] = "onAddClip";
};
function shotgun_noclipImage::onAddClip(%this, %obj, %slot)
{	
	%clip = %this.clip;
	%ammo = %this.ammo;
	//if they have a clip
	if( %obj.getInventory(shotgunclip) )
	{	
		%obj.decInventory(shotgun_noclip, 1);		//take the player's noclip
		%obj.incInventory(shotgun, 1);	//hack		//give them a regular 
		%obj.decInventory(shotgunclip, 1);			//take away 1  clip
		%obj.incInventory(shotgunammo, 1);		//give them  rounds

		//fix mounts
		%obj.unmountImage(%slot);
		%obj.mountImage(shotgunImage, %slot);	//hack
	}
	else
	{
		//this should never happen
		messageClient( %obj.client, 'MsgCantUsePack', '\c2No more Shotgun Shells!~wfx/misc/misc.error.wav' );
		%obj.decInventory(shotgun_noclip, 1);		//take the player's noclip
		%obj.incInventory(shotgun, 1);	//hack		//give them a regular 
		
		//fix mounts
		%obj.unmountImage(%slot);
		%obj.mountImage(shotgunImage, %slot);	//hack
	}
}
function shotgun_noclipImage::changeClip(%this, %obj, %slot)
{	
	if(%obj.getInventory(shotgunclip) == 0)
	{
		messageClient( %obj.client, sometype, '\c2No more shotgun shells!~wfx/misc/misc.error.wav' );
		return;
	}
	else
	{
		%obj.decinventory(shotgun_noclip, 1);
		%obj.unmountImage(%slot);
		%obj.incinventory(shotgun_noclip, 1);
		%obj.mountImage(shotgun_noclipImage, %slot);		
	}
}

//////////
//weapon//
//////////

datablock ItemData(shotgun)
{
	category	= "Weapon";
	className = Weapon;
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	image = shotgunImage;
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "a Shotgun";
	computeCRC = true;
	emap = true;
	rotation = "1 1 1 1";
	packImage = shotgunpackImage;
	slot = $SecondarySlot;
	emptyItem	= shotgun_noclip;
};
datablock ShapeBaseImageData(shotgunpackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.07 -0.1 0.1";
	rotation = eulerToMatrix( "-90 0 0" );
};

datablock ShapeBaseImageData(shotgunImage)
{
	accuracy = 0.01;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	item = shotgun;
	ammo = shotgunammo;
	clip = shotgunclip;
	offset = "0 0 0";
	emap = true;
	projectile = pelletProjectile;		
	projectileType = Projectile;	
	
	armThread = lookrifle;


	casing              = shotgunshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = shotgunSwitchSound;
	stateAllowImageChange[0] = true;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";

	stateName[3] = "Fire";
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.15;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = shotgunFireSound;

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Cock";
	stateSequence[4] = "Reload";

	stateName[5] = "Cock";			//hehe... cock..
	stateEjectShell[5]       = true;
	stateAllowImageChange[5] = false;
	stateTimeoutValue[5] = 0.5;
	stateTransitionOnTimeout[5] = "Ready";
	stateSequence[5] = "Activate";
	stateSound[5] = shotgunCockSound;

	stateName[6] = "NoAmmo";
	stateTransitionOnAmmo[6] = "Reload";
	stateSequence[6] = "Empty";
	stateTransitionOnTriggerDown[6] = "DryFire";

	stateName[7] = "DryFire";
	stateSound[7] = shotgunDryFireSound;
	stateTransitionOnTriggerUp[7] = "NoAmmo";
};

function shotgunImage::onFire(%this, %obj, %slot)
{
	echo("shotgun fire");
	%projectile = %this.projectile;

	//	Decrement inventory ammo. The image's ammo state is update
	//	automatically by the ammo inventory hooks.
	%obj.decInventory(%this.ammo,1);

	//	Determin initial projectile velocity based on the 
	//	gun's muzzle point and the object's current velocity
	%muzzleVector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%muzzleVelocity = VectorAdd(
	VectorScale(%muzzleVector, %projectile.muzzleVelocity),
	VectorScale(%objectVelocity, %projectile.velInheritFactor));

	//	Create the projectile object
	for(%i = 0;  %i < 9; %i++)
	{
		%xrand = (getRandom() * 0.2) - (0.2/2);
		%yrand = (getRandom() * 0.2) - (0.2/2);
		%zrand = (getRandom() * 0.2) - (0.2/2);
		%muzzleVector = %obj.getMuzzleVector(%slot);
		%muzzleVector = VectorAdd(%muzzleVector, %xrand @ " " @ %yrand @ " " @ %zrand);
		%muzzleVector = VectorNormalize(%muzzleVector);
		%pelletVelocity = VectorAdd(
			VectorScale(%muzzleVector, %projectile.muzzleVelocity),
			VectorScale(%objectVelocity, %projectile.velInheritFactor));
		%p	= new (%this.projectileType)()
		{
			dataBlock	 = %projectile;
			initialVelocity	 = %pelletVelocity;
			initialPosition	 = %obj.getMuzzlePoint(%slot);
			sourceObject	 = %obj;
			sourceSlot	 = %slot;
			client		 = %obj.client;
			};
		MissionCleanup.add(%p);
	}
	return %p;

}

function shotgunImage::changeClip(%data, %obj, %slot)
{
	if(%obj.getInventory(shotgunammo) == %obj.getDataBlock().maxInv[shotgunammo])
	{
		messageClient( %obj.client, sometype, '\c2Shotgun Full!~wfx/misc/misc.error.wav' );
		return;
	}
	if(%obj.getInventory(shotgunclip) == 0)
	{
		messageClient( %obj.client, sometype, '\c2No more shotgun shells!~wfx/misc/misc.error.wav' );
		return;
	}
	if(%obj.getImageState($WeaponSlot) $= "Ready" || %obj.getImageState($WeaponSlot) $= "NoAmmo" )
	{
		%obj.decInventory(shotgun, 1);			//take away m16
		%obj.incInventory(shotgun_noclip, 1);		//give noclip m16
		//throw	clip debris??
		//unmount and mount
		%obj.unmountImage(%slot);			//unnessesary? 
		%obj.mountImage(shotgun_noclipImage, %slot);	//dont forget that you mount IMAGES 
	}
}