datablock ParticleData(tankTireParticle)
{
   textureName          = "~/data/shapes/vehicles/dustParticle";
   dragCoefficient      = 2.0;
   gravityCoefficient   = -0.1;
   inheritedVelFactor   = 0.1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 0;
   colors[0]     = "0.46 0.36 0.26 1.0";
   colors[1]     = "0.46 0.46 0.36 0.0";
   sizes[0]      = 1.50;
   sizes[1]      = 2.0;
};

datablock ParticleEmitterData(tankTireEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 5;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "tankTireParticle";
};


//----------------------------------------------------------------------------

datablock WheeledVehicleTire(tankTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "~/data/shapes/vehicles/jeeptire.dts";
   friction = 100000; //1.5;

   // Spring that generates lateral tire forces
   lateralForce = 4000;
   lateralDamping = 6000;
   lateralRelaxation = 0.1;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 6000;
   longitudinalDamping = 4000;
   longitudinalRelaxation = 0.1;
};

datablock WheeledVehicleTire(tankFrontTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "~/data/shapes/vehicles/tankfronttire.dts";
   friction = 100000; //1.5;

   // Spring that generates lateral tire forces
   lateralForce = 4000;
   lateralDamping = 6000;
   lateralRelaxation = 0.1;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 6000;
   longitudinalDamping = 4000;
   longitudinalRelaxation = 0.1;
};
datablock WheeledVehicleTire(tankRearTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "~/data/shapes/vehicles/tankreartire.dts";
   friction = 100000; //1.5;

   // Spring that generates lateral tire forces
   lateralForce = 4000;
   lateralDamping = 6000;
   lateralRelaxation = 0.1;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 6000;
   longitudinalDamping = 4000;
   longitudinalRelaxation = 0.1;
};

datablock WheeledVehicleSpring(tankSpring)
{
   // Wheel suspension properties
   length = 0.3;			 // Suspension travel
   force = 12000; //3000;		 // Spring force
   damping = 2400; //600;		 // Spring damping
   antiSwayForce = 12; //3;		 // Lateral anti-sway force
};

datablock WheeledVehicleTire(tankFlatTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "~/data/shapes/vehicles/jeepFlatTire.dts";
   friction = 10000;

   // Spring that generates lateral tire forces
   lateralForce = 6000;
   lateralDamping = 4000;
   lateralRelaxation = 0.1;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 600;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.1;
};
datablock WheeledVehicleSpring(tankFlatSpring)
{
   // Wheel suspension properties
   length = 0;			// Suspension travel
   force = 300;			// Spring force
   damping = 60;		// Spring damping
   antiSwayForce = 3;		// Lateral anti-sway force
};




datablock WheeledVehicleData(tank)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "~/data/shapes/vehicles/tank.dts";
	emap = true;
	nummountpoints = 2;
	minMountDist = 3;

	maxDamage = 2000.00;
	destroyedLevel = 2000.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	maxSteeringAngle = 0.785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = tankTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 8;         // Far distance from vehicle
	cameraOffset = 4.5;        // Vertical offset from camera mount point
	cameraLag = 0.1;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag

	useEyePoint = false;	


	defaultTire	= tankTire;
	defaultSpring	= tankSpring;
	flatTire	= tankFlatTire;
	flatSpring	= tankFlatSpring;


	// Rigid Body
	mass = 1600;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 1.6;
	bodyRestitution = 0.4;
	minImpactSpeed = 5;        // Impacts over this invoke the script callback
	softImpactSpeed = 5;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8000; //4000;       // Engine power
	engineBrake = 6000;         // Braking when throttle is 0
	brakeTorque = 5000000;        // When brakes are applied
	maxWheelSpeed = 20;        // Engine scale by current speed / max speed

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;


	splash = PlayerSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 0.4;
	splashEmitter[0] = PlayerFoamDropletsEmitter;
	splashEmitter[1] = PlayerFoamEmitter;
	splashEmitter[2] = PlayerBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;

	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	wheelImpactSound = clatchSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;
};

function tank::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	%obj.setDamageLevel(%obj.getDamageLevel() + (%damage));

	if(%obj.getDamageLevel() >= %this.maxDamage)
	{	
		%obj.setDamageLevel(%this.maxDamage * 0.75);
		if(%damage > 50)
		{
			%obj.setWheelSpring(mfloor(getRandom() * 4), %this.flatSpring);
		}
		else
		{
			%obj.setWheelTire(mfloor(getRandom() * 4), %this.flatTire);
		}
	}
	if(%damage < 0 && %obj.getDamageLevel() == 0)
	{
		%obj.setWheelSpring(mfloor(getRandom() * 4), %this.defaultSpring);
		%obj.setWheelTire(mfloor(getRandom() * 4), %this.defaultTire);
	}

}

function tank::onAdd(%this,%obj)
{
	// add wheels
	%obj.setShapeName(%obj.getDataBlock().displayName);
	%obj.setWheelTire(0,tankfrontTire);
	%obj.setWheelTire(1,tankfrontTire);
	%obj.setWheelTire(2,tankfrontTire);
	%obj.setWheelTire(3,tankfrontTire);
	%obj.setWheelTire(4,tankrearTire);
	%obj.setWheelTire(5,tankrearTire);
	

	

	for (%i = %obj.getWheelCount() - 1; %i >= 0; %i--) 
	{
		%obj.setWheelSpring(%i,%obj.getDataBlock().defaultSpring);
	}
}

//-----------------------------------------------------------------------------


datablock ItemData(tankSpawner)
{
	category = "Special";
	className = "Ammo";
	shapeFile = "~/data/shapes/markers/octahedron.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 0;
	computeCRC = true;
};

function tankSpawner::onAdd(%this,%obj)
{
	%newcar = new WheeledVehicle() 
	{
		dataBlock = tank;
	};
	%newcar.setTransform(%obj.getTransform());

	%turret = new Player()
	{
		dataBlock = tankTurret;
	};
	%turret.playthread(0, look);	//start the look thread
	%turret.mountImage(tankGunImage, 0);
	%turret.invInventory(tankShellAmmo, 50);
	%newcar.mountObject(%turret, 1);
}

datablock PlayerData(tankTurret)
{
 renderFirstPerson = true;
   emap = true;
   
   className = Turret;
   shapeFile = "~/data/shapes/vehicles/tankTurret.dts";
   cameraMaxDist = 3;
   computeCRC = true;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   debrisShapeName = "~/data/shapes/player/debris_player.dts";
   debris = playerDebris;

   aiAvoidThis = true;

   minLookAngle = -0.75;
   maxLookAngle = 0.75;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0.3;  //1.5; //for paracute
   maxdrag = 0.4;
   density = 1.1; //10;
   maxDamage = 100;
   maxEnergy =  60;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.256;

   runForce = 48 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 14;
   maxBackwardSpeed = 13;
   maxSideSpeed = 13;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 15;

   recoverDelay = 9;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 20;
   speedDamageScale = 2.0;

   boundingBox = "1.75 1.75 0.75";
   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   decalData   = LightMaleFootprint;
   decalOffset = 0.25;
   
   footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.4;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 70;
   jumpSurfaceAngle = 80;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   // Footstep Sounds
   FootSoftSound        = FootLightSoftSound;
   FootHardSound        = FootLightHardSound;
   FootMetalSound       = FootLightMetalSound;
   FootSnowSound        = FootLightSnowSound;
   FootShallowSound     = FootLightShallowSplashSound;
   FootWadingSound      = FootLightWadingSound;
   FootUnderwaterSound  = FootLightUnderwaterSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Allowable Inventory Items
	maxInv[tankShellAmmo] = 50;
	maxInv[m16ammo] = 50;
};

function tankTurret::onTrigger(%this, %obj, %triggerNum, %val)
{
	if(%triggerNum == 2 && %val == 1)
	{
		%client = %obj.getControllingClient();
		%client.setControlObject = %client.player;
	}
}


function tankTurret::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	//do nothing
	//put stuff here for interesting dynamic where turret can be destroyed seperately from tank
}


//AMMO
datablock ItemData(tankShellAmmo)
{
	className = Ammo;
	shapeFile = "~/data/shapes/weapons/shotgunClip.dts";
	mass = 1;
	elasticity = 0.2;
	friction = 0.6;
	pickupRadius = 2;
	pickUpName = "some tank shells.";
	computeCRC = true;
};



//////////////////////////////
//// PROJECTILE
/////////////////////////////
//explosion
datablock ParticleData(tankShellExplosionParticle1)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 400;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   useInvAlpha = false;
   colors[0] = "0.4 0.4 0.4 1.0";
   colors[1] = "0.4 0.4 0.4 1.0";
   colors[2] = "0.4 0.4 0.4 0.0";
   sizes[0]      = 0.05;
   sizes[1]      = 0.05;
   sizes[2]      = 0.01;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tankShellExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 2;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 20;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = true; //false;
   orientParticles  = true;
   lifetimeMS       = 40;
   particles = "tankShellExplosionParticle1";
};

datablock ParticleData(tankShellSmokeParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.2;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.7 0.7 0.7 0.4";
   colors[2]     = "0.7 0.7 0.7 0.0";
   sizes[0]      = 0.25;
   sizes[1]      = 0.25;
   sizes[2]      = 0.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(tankShellSmokeEmitter)
{
   ejectionPeriodMS = 16;
   periodVarianceMS = 1;
   ejectionVelocity = 1.0;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 35;
   overrideAdvances = false;
   particles = "tankShellSmokeParticle";
   lifetimeMS       = 50;
};

datablock ExplosionData(tankShellExplosion)
{
   //soundProfile   = pelletImpactSound;
   //shockwave = pelletHit;
   faceViewer = true;
   emitter[0] = tankShellExplosionEmitter;
   emitter[1] = tankShellSmokeEmitter;
};

datablock ProjectileData(tankShellProjectile)
{
	projectileShapeName = "~/data/shapes/weapons/bullet.dts";
   emitterDelay        = -1;
   directDamage        = 6;
   directDamageType    = $DamageType::pellet;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //pelletFlightSound;
   velInheritFactor    = 1.0;

   explosion           = "tankShellExplosion";
   splash              = BlasterSplash;


	isBallistic         = true;
   grenadeElasticity = 0; //0.2998;
   grenadeFriction   = 1.0;
   armingDelayMS     = 0;

   muzzleVelocity    = 45.0;

   drag = 0.05; //0.05;

   gravityMod        = 1.0;

   dryVelocity       = 75.0;
   wetVelocity       = 25.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "10.75 10.75 10.75";
   crossViewAng = 0.99;
   crossSize = 0.05;

   lifetimeMS     = 3000;
   blurLifetime   = 0.05;
   blurWidth      = 0.05;
   blurColor = "0.4 0.4 0.4 1.0";

   texture[0] = "~/data/shapes/rifle/smokeParticle";
   texture[1] = "~/data/shapes/rifle/smokeParticle";

   decalData[0] = pelletdecal;

};


//TANK GUN IMAGE
datablock ShapeBaseImageData(tankGunImage)
{
	accuracy = 0.01;
	accuracyStep = 0.0;
	maxAccuracy = 0.10;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/shotgun.dts";
	item = shotgun;
	ammo = tankShellAmmo;
	clip = "";
	offset = "0 0 0";
	emap = true;
	projectile = tankShellProjectile;		
	projectileType = Projectile;	
	
	armThread = look;


	casing              = shotgunshell;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "ActivateReady";
	stateTimeoutValue[0] = 0.25;
	stateSequence[0] = "Full";
	stateSound[0] = shotgunSwitchSound;
	stateAllowImageChange[0] = true;

	stateName[1] = "ActivateReady";
	stateTransitionOnLoaded[1] = "Ready";
	stateTransitionOnNoAmmo[1] = "NoAmmo";

	stateName[2] = "Ready";
	stateSequence[2] = "Release";
	stateTransitionOnNoAmmo[2] = "NoAmmo";
	stateTransitionOnTriggerDown[2] = "Fire";

	stateName[3] = "Fire";
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "Reload";
	stateTimeoutValue[3] = 0.15;
	stateFire[3] = true;
	stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = shotgunFireSound;

	stateName[4] = "Reload";
	stateAllowImageChange[4] = false;
	stateTransitionOnTriggerUp[4] = "Cock";
	stateSequence[4] = "Reload";

	stateName[5] = "Cock";			//hehe... cock..
	stateEjectShell[5]       = true;
	stateAllowImageChange[5] = false;
	stateTimeoutValue[5] = 0.5;
	stateTransitionOnTimeout[5] = "Ready";
	stateSequence[5] = "Activate";
	stateSound[5] = shotgunCockSound;

	stateName[6] = "NoAmmo";
	stateTransitionOnAmmo[6] = "Reload";
	stateSequence[6] = "Empty";
	stateTransitionOnTriggerDown[6] = "DryFire";

	stateName[7] = "DryFire";
	stateSound[7] = shotgunDryFireSound;
	stateTransitionOnTriggerUp[7] = "NoAmmo";
};