

datablock AudioProfile(thermGrenadeExplodeSound)
{
   filename    = "~/data/sound/EXPLOSIVEROUND.wav";
   description = AudioClosest3d;
   preload = true;
};



datablock AudioProfile(thermHitSound)
{
   filename    = "~/data/sound/ricochet1.wav";
   description = AudioClosest3d;
   preload = true;
};

//item
datablock ItemData(thermGrenade)
{
	category	= "Weapon";
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/grenade2.dts";
	image		= thermGrenadeImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "some thermite grenades.";
	computeCRC	= true;
	emap		= false;
	maxinventory	= 4;
	packImage = thermGrenadePackImage;
	slot = $GrenadeSlot;
	emptyItem = thermGrenade;
	fullItem = thermGrenade;
};

//pack image
datablock ShapeBaseImageData(thermGrenadePackImage)
{
	className = PackImage;
	shapeFile = "~/data/shapes/weapons/grenade2.dts";
	emap = true;
	mountPoint = $HipPoint;
	offset = "0.17 -0.14 0";
	rotation = eulerToMatrix( "-20 15 105" );
};

//spoon
datablock DebrisData(spoon)
{
   shapeName = "~/data/shapes/weapons/spoon.dts";

   lifetime = 3.0;

   minSpinSpeed = 600.0;
   maxSpinSpeed = 800.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};      

//weapon image
datablock ShapeBaseImageData(thermGrenadeImage)
{
	accuracy = 0.01;
	accuracyStep = 0.01;
	maxAccuracy = 0.2;
	className = "WeaponImage";
	shapeFile = "~/data/shapes/weapons/grenade.dts";
	item = thermGrenade;
	ammo = "";
	clip = "";
	offset = "0 0 0";
	emap = false;
	projectile = thermGrenadeProjectile;		
	projectileType = Projectile;	
	
	armThread = looksn;

	casing              = spoon;
	shellExitDir        = "1.0 0.3 1.0";
	shellExitOffset     = "0.15 -0.56 -0.1";
	shellExitVariance   = 15.0;
	shellVelocity       = 5.0;

	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.5;
	stateSequence[0] = "Full";
	stateAllowImageChange[0]	= true;
	stateSound[0] = m16SwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Charge";
	stateTransitionOnTriggerUp[2]	= "Fire";
	stateTransitionOnTimeout[2]	= "Fire";
	stateTimeoutValue[2]		= "3.9";
	stateWaitForTimeout[2]		= false;
	stateAllowImageChange[2]	= false;
	stateScript[2]			= "onCharge";
	stateEjectShell[2]		= true;
	stateSound[2]			= grenadeArmSound;

	stateName[3] = "Fire";
	stateEjectShell[3]       = true;
	stateSequence[3] = "Fire";
	stateTransitionOnTimeout[3] = "ready";
	stateTimeoutValue[3] = 0.5;
	stateFire[3] = true;
	//stateRecoil[3] = LightRecoil;
	stateAllowImageChange[3] = false;
	stateScript[3] = "onFire";
	stateSound[3] = grenadeThrowSound;
	
};

function thermGrenadeImage::onCharge(%this, %obj, %slot)
{
	%projectile = %this.projectile;
	%p = new (item)() 
	{
		dataBlock        = armedthermGrenade;
		initialVelocity  = "0 0 0";
		initialPosition  = "0 0 -1000";
		sourceObject     = %obj;
		sourceSlot       = %slot;
		client           = %obj.client;
	};
	schedule(4000, %p, explodethermGrenade, %p);

	%obj.currGrenade = %p;
}

function thermGrenadeImage::onFire(%this, %obj, %slot)
{

	%muzzleVector = %obj.getEyeVector();
	%muzzleVelocity = vectorScale(%muzzleVector, 20);
	
	%objectVelocity = %obj.getVelocity();

	%muzzleVelocity = vectorAdd(%muzzleVelocity, %objectVelocity);
	
	%obj.currGrenade.setTransform(vectorAdd(%obj.getMuzzlePoint(%slot), %muzzleVector));
	%obj.currGrenade.setVelocity(%muzzleVelocity);

	%obj.currGrenade = 0;
	%obj.decInventory(thermGrenade, 1);
}


//thrown item
datablock ItemData(armedthermGrenade)
{
	className	= Weapon;
	shapeFile	= "~/data/shapes/weapons/grenade.dts";
	image		= thermGrenadeImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "an armed therm grenade *BORK!*";
	computeCRC	= true;
	emap		= false;
	rotation	= eulerToMatrix("90 0 0");
};

function explodethermGrenade(%obj)
{
	//echo(%obj SPC "BOOOOOM!!");
	%e = new Explosion()
	{
		datablock = thermExplosion;
	};


	%e.setTransform(%obj.getTransform());

	radiusDamage(%obj,%obj.getPosition(), 12, 100 ,%this.radiusDamageType,0);
	radiusImpulse(%obj.getPosition(), 10, 10);

	

	%objPos=  %obj.getPosition();

	for(%i = 0; %i < 10; %i++)
	{
		%xrand = (getRandom() * 300) - 150;
		%yrand = (getRandom() * 300) - 150;
		%zrand = (getRandom() * 300) - 150;
		%s = new (projectile)()
		{
			datablock = shrapnel;
			initialPosition = %objPos;
			initialVelocity = %xrand SPC %yrand SPC %zrand;
		};
	}

	%obj.schedule(200, delete);
}

//explosion effect

datablock ParticleData(thermParticle1)
{
   dragCoefficient      = 15.0;
   gravityCoefficient   = -7.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 300;
   useInvAlpha          = true;
   spinRandomMin        = 00.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.6 0.1 0.7";
   colors[1]     = "0.1 0.1 0.1 0.5";
   colors[2]     = "0.2 0.2 0.2 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 3;
   sizes[2]      = 4;
   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(thermEmitter1)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 40.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "thermParticle1";
   lifetimeMS       = 100;
};


datablock ParticleData(thermParticle2)
{
   dragCoefficient      = 2.0;
   gravityCoefficient   = 5.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 200;
   useInvAlpha          = true;
   spinRandomMin        = -90.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.7 0.3 1.0";
   colors[1]     = "0.9 0.3 0.3 0.5";
   colors[2]     = "0.3 0.3 0.3 0.0";
   sizes[0]      = 2;
   sizes[1]      = 1;
   sizes[2]      = 1;
   times[0]      = 0.0;
   times[1]      = 0.4;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(thermEmitter2)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 50.0;
   velocityVariance = 10.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "thermParticle2";
   lifetimeMS       = 50;
};

datablock ExplosionData(thermExplosion)
{
	soundProfile   = grenadeExplodeSound;
	faceViewer = false;
	emitter[0] = thermEmitter1;
	emitter[1] = thermEmitter2;
};



//Shrapnel
datablock ParticleData(shrapnelParticle1)
{
   dragCoefficient      = 5.0;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 300;
   useInvAlpha          = true;
   spinRandomMin        = 00.0;
   spinRandomMax        = 90.0;
   textureName          = "~/data/shapes/rifle/smokeParticle";
   colors[0]     = "0.9 0.9 0.0 1.0";
   colors[1]     = "0.9 0.9 0.0 0.5";
   colors[2]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.2;
   sizes[1]      = 0.1;
   sizes[2]      = 0.05;
   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(shrapnelEmitter1)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 5.0;
   velocityVariance = 10.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "shrapnelParticle1";
   lifetimeMS       = 50;
};

datablock ExplosionData(shrapnelExplosion)
{
	soundProfile   = shrapnelHitSound;
	faceViewer = false;
	emitter[0] = shrapnelEmitter1;
};



datablock ProjectileData(shrapnel)
{
	projectileShapeName = "~/data/shapes/weapons/bullet.dts";
   emitterDelay        = -1;
   directDamage        = 10;
   directDamageType    = $DamageType::mm9;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = none; //mm9FlightSound;
   velInheritFactor    = 1.0;

   explosion           = shrapnelExplosion;
   splash              = BlasterSplash;

armingDelay         = 100;
   explodeOnArm		= false;
   lifetime            = 2000;
   fadeDelay           = 600;
   bounceElasticity    = 0.8;
   bounceFriction      = 0.0;
   isBallistic         = true;
   gravityMod = 1.0;



   muzzleVelocity    = 150.0;

   drag = 0.05; //0.05;

   gravityMod        = 1.0;

   dryVelocity       = 150.0;
   wetVelocity       = 150.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = false;
   //lightRadius = 3.0;
   //lightColor  = "0.5 0.175 0.175";

   scale = "0.75 0.75 0.75";
   crossViewAng = 0.99;
   crossSize = 0.05;

   lifetimeMS     = 3000;
   blurLifetime   = 0.05;
   blurWidth      = 0.05;
   blurColor = "0.4 0.4 0.4 1.0";

   texture[0] = "~/data/shapes/rifle/smokeParticle";
   texture[1] = "~/data/shapes/rifle/smokeParticle";

   decalData[0] = mm9decal;
	
	scale = "1 2 1";
};