//---------------------------------------------
//  wall pack- deployable.  Cant have a base without at least 1100 walls
//------------------------------------------------

datablock ItemData(wallPack)
{
	category	= "Deployable";
	className	= Deployable;
	staticShape	= deployedwall;
	shapeFile	= "~/data/shapes/items/wallPack.dts";
	image		= wallPackImage;
	mass		= 1;
	elasticity	= 0.2;
	friction	= 0.6;
	pickupRadius	= 2;
	pickUpName	= "some deployable walls";
	computeCRC	= true;
	emap		= true;
	maxInventory	= 5;
};

datablock ShapeBaseImageData(wallPackImage)
{
	className = PackImage;
	item = wallPack;
	shapeFile = "~/data/shapes/items/wallPack.dts";
	emap = true;
	mountPoint = $BackPoint;
	offset = "0.0 -0.15 -0.1";
	scale = "0.5 0.5 0.5";
	rotation = eulertomatrix("0 0 0");
};

datablock StaticShapeData(deployedwall)
{
	pack = wallPack;
	className = Station;
	shapeFile = "~/data/shapes/items/wall.dts";
	maxDamage = 500;
	destroyedLevel = 500;
	disabledLevel = 400;
	explosion      = DeployablesExplosion;
	expDmgRadius = 8.0;
	expDamage = 0.35;
	expImpulse = 500.0;

	dynamicType = $TypeMasks::StationObjectType;
	isShielded = true;
	energyPerDamagePoint = 110;
	maxEnergy = 50;
	rechargeRate = 0.20;
	renderWhenDestroyed = false;
	doesRepair = true;

	deployedObject = true;

	cmdCategory = "DSupport";
	cmdIcon = CMDStationIcon;
	//cmdMiniIconName = "commander/MiniIcons/com_inventory_grey";
	targetNameTag = 'Deployable';
	targetTypeTag = 'Station';

	//debrisShapeName = "debris_generic_small.dts";
	debris = DeployableDebris;
	heatSignature = 0;
};

